# Code generated by qwick.

import numpy as np
from ebcc.util import pack_2e, einsum, Namespace

def energy(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, **kwargs):
    # energy
    x0 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x0 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1)) * -0.5
    x0 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    e_cc = 0
    e_cc += einsum(t2, (0, 1, 2, 3), x0, (0, 1, 2, 3), ()) * 2.0
    del x0
    x1 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x1 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1))
    x1 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x2 = np.zeros((nocc, nvir), dtype=np.float64)
    x2 += einsum(f.ov, (0, 1), (0, 1))
    x2 += einsum(t1, (0, 1), x1, (0, 2, 3, 1), (2, 3))
    del x1
    e_cc += einsum(t1, (0, 1), x2, (0, 1), ()) * 2.0
    del x2

    return e_cc

def update_amps(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, **kwargs):
    # T amplitudes
    t1new = np.zeros((nocc, nvir), dtype=np.float64)
    t1new += einsum(f.ov, (0, 1), (0, 1))
    t2new = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    t2new += einsum(t1, (0, 1), v.ooov, (2, 0, 3, 4), (3, 2, 4, 1)) * -1.0
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 3), (0, 4, 2, 5)) * 2.0
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 2), (0, 4, 5, 3)) * -1.0
    t2new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 1, 5, 3), (0, 4, 2, 5)) * -1.0
    t2new += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x0 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x0 += einsum(v.ovvv, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x0 += einsum(v.ovvv, (0, 1, 2, 3), (0, 2, 1, 3))
    t1new += einsum(t2, (0, 1, 2, 3), x0, (1, 2, 3, 4), (0, 4)) * 2.0
    x1 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x1 += einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    x2 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x2 += einsum(v.ooov, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x2 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x2 += einsum(x1, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x2 += einsum(x1, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    t1new += einsum(t2, (0, 1, 2, 3), x2, (4, 0, 1, 3), (4, 2)) * -1.0
    del x2
    x3 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x3 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1))
    x3 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x4 = np.zeros((nocc, nvir), dtype=np.float64)
    x4 += einsum(t1, (0, 1), x3, (0, 2, 3, 1), (2, 3)) * 2.0
    x5 = np.zeros((nocc, nvir), dtype=np.float64)
    x5 += einsum(f.ov, (0, 1), (0, 1))
    x5 += einsum(x4, (0, 1), (0, 1))
    del x4
    x6 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x6 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x6 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t1new += einsum(x5, (0, 1), x6, (0, 2, 3, 1), (2, 3))
    del x6
    x7 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x7 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x7 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    t1new += einsum(t1, (0, 1), x7, (0, 2, 1, 3), (2, 3)) * 2.0
    del x7
    x8 = np.zeros((nvir, nvir), dtype=np.float64)
    x8 += einsum(f.vv, (0, 1), (0, 1))
    x8 += einsum(t1, (0, 1), x0, (0, 2, 1, 3), (2, 3)) * 2.0
    del x0
    t1new += einsum(t1, (0, 1), x8, (1, 2), (0, 2))
    del x8
    x9 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x9 += einsum(v.ooov, (0, 1, 2, 3), (0, 1, 2, 3))
    x9 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x10 = np.zeros((nocc, nocc), dtype=np.float64)
    x10 += einsum(t1, (0, 1), x5, (2, 1), (2, 0))
    del x5
    x11 = np.zeros((nocc, nocc), dtype=np.float64)
    x11 += einsum(f.oo, (0, 1), (0, 1))
    x11 += einsum(t2, (0, 1, 2, 3), x3, (1, 4, 2, 3), (4, 0)) * 2.0
    x11 += einsum(t1, (0, 1), x9, (2, 3, 0, 1), (3, 2)) * 2.0
    x11 += einsum(x10, (0, 1), (0, 1))
    t1new += einsum(t1, (0, 1), x11, (0, 2), (2, 1)) * -1.0
    del x11
    x12 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x12 += einsum(t1, (0, 1), x1, (2, 3, 4, 1), (2, 0, 4, 3))
    t2new += einsum(t2, (0, 1, 2, 3), x12, (4, 5, 1, 0), (5, 4, 2, 3))
    x13 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x13 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 5, 1, 2), (0, 4, 3, 5))
    t2new += einsum(x13, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x14 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x14 += einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    x15 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x15 += einsum(t2, (0, 1, 2, 3), x14, (4, 1, 5, 2), (4, 0, 3, 5))
    x16 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x16 += einsum(t1, (0, 1), x1, (2, 3, 0, 4), (2, 3, 1, 4))
    x17 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x17 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    x17 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x18 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x18 += einsum(t2, (0, 1, 2, 3), x17, (1, 4, 3, 5), (4, 0, 5, 2)) * 0.5
    del x17
    x19 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x19 += einsum(x16, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x16
    x19 += einsum(x18, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x18
    x20 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x20 += einsum(t2, (0, 1, 2, 3), x19, (4, 1, 5, 2), (4, 0, 5, 3)) * 2.0
    del x19
    x21 = np.zeros((nvir, nvir), dtype=np.float64)
    x21 += einsum(t2, (0, 1, 2, 3), x3, (0, 1, 4, 2), (4, 3)) * 2.0
    x22 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x22 += einsum(v.ovvv, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x22 += einsum(v.ovvv, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x23 = np.zeros((nvir, nvir), dtype=np.float64)
    x23 += einsum(t1, (0, 1), x22, (0, 2, 1, 3), (2, 3))
    del x22
    x24 = np.zeros((nvir, nvir), dtype=np.float64)
    x24 += einsum(x21, (0, 1), (0, 1))
    del x21
    x24 += einsum(x23, (0, 1), (0, 1)) * -1.0
    del x23
    x25 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x25 += einsum(x24, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4))
    del x24
    x26 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x26 += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 2), (0, 4, 5, 3))
    x27 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x27 += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    x28 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x28 += einsum(x1, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x28 += einsum(x1, (0, 1, 2, 3), (0, 2, 1, 3))
    x29 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x29 += einsum(t2, (0, 1, 2, 3), x28, (4, 5, 1, 3), (4, 5, 0, 2)) * 2.0
    del x28
    x30 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x30 += einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    x31 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x31 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x31 += einsum(x30, (0, 1, 2, 3), (1, 0, 2, 3))
    x32 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x32 += einsum(t1, (0, 1), x31, (2, 3, 1, 4), (2, 3, 0, 4))
    del x31
    x33 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x33 += einsum(x26, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x26
    x33 += einsum(x27, (0, 1, 2, 3), (0, 1, 2, 3))
    del x27
    x33 += einsum(x29, (0, 1, 2, 3), (0, 2, 1, 3))
    del x29
    x33 += einsum(x32, (0, 1, 2, 3), (2, 1, 0, 3))
    del x32
    x34 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x34 += einsum(t1, (0, 1), x33, (2, 3, 0, 4), (2, 3, 4, 1))
    del x33
    x35 = np.zeros((nocc, nocc), dtype=np.float64)
    x35 += einsum(t2, (0, 1, 2, 3), x3, (1, 4, 2, 3), (4, 0))
    x36 = np.zeros((nocc, nocc), dtype=np.float64)
    x36 += einsum(t1, (0, 1), x9, (2, 3, 0, 1), (2, 3))
    del x9
    x37 = np.zeros((nocc, nocc), dtype=np.float64)
    x37 += einsum(x35, (0, 1), (0, 1))
    del x35
    x37 += einsum(x36, (0, 1), (1, 0))
    del x36
    x38 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x38 += einsum(x37, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3)) * 2.0
    del x37
    x39 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x39 += einsum(x15, (0, 1, 2, 3), (0, 1, 2, 3))
    del x15
    x39 += einsum(x20, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x20
    x39 += einsum(x25, (0, 1, 2, 3), (1, 0, 3, 2))
    del x25
    x39 += einsum(x34, (0, 1, 2, 3), (0, 1, 3, 2))
    del x34
    x39 += einsum(x38, (0, 1, 2, 3), (1, 0, 3, 2))
    del x38
    t2new += einsum(x39, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new += einsum(x39, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x39
    x40 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x40 += einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    x41 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x41 += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    x42 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x42 += einsum(t2, (0, 1, 2, 3), x41, (4, 5, 0, 1), (4, 5, 2, 3))
    del x41
    x43 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x43 += einsum(t2, (0, 1, 2, 3), x14, (4, 1, 5, 3), (4, 0, 2, 5))
    del x14
    x44 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x44 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x44 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x45 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x45 += einsum(x30, (0, 1, 2, 3), x44, (1, 4, 5, 2), (4, 0, 5, 3)) * 2.0
    del x44
    x46 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x46 += einsum(t1, (0, 1), v.oovv, (2, 3, 4, 1), (0, 2, 3, 4))
    x47 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x47 += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 1, 5, 3), (0, 4, 5, 2))
    x48 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x48 += einsum(t2, (0, 1, 2, 3), x1, (4, 5, 1, 2), (4, 0, 5, 3))
    del x1
    x49 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x49 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 0.5
    x49 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x49 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    x50 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x50 += einsum(v.ooov, (0, 1, 2, 3), x49, (2, 4, 5, 3), (0, 1, 4, 5)) * 2.0
    del x49
    x51 = np.zeros((nocc, nvir), dtype=np.float64)
    x51 += einsum(t1, (0, 1), x3, (0, 2, 3, 1), (2, 3))
    del x3
    x52 = np.zeros((nocc, nvir), dtype=np.float64)
    x52 += einsum(f.ov, (0, 1), (0, 1)) * 0.5
    x52 += einsum(x51, (0, 1), (0, 1))
    del x51
    x53 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x53 += einsum(x52, (0, 1), t2, (2, 3, 1, 4), (0, 2, 3, 4)) * 2.0
    del x52
    x54 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x54 += einsum(x46, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    del x46
    x54 += einsum(x47, (0, 1, 2, 3), (2, 0, 1, 3))
    del x47
    x54 += einsum(x48, (0, 1, 2, 3), (2, 0, 1, 3))
    del x48
    x54 += einsum(x50, (0, 1, 2, 3), (1, 2, 0, 3))
    del x50
    x54 += einsum(x53, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x53
    x55 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x55 += einsum(t1, (0, 1), x54, (0, 2, 3, 4), (2, 3, 4, 1))
    del x54
    x56 = np.zeros((nocc, nocc), dtype=np.float64)
    x56 += einsum(f.oo, (0, 1), (0, 1))
    x56 += einsum(x10, (0, 1), (1, 0))
    del x10
    x57 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x57 += einsum(x56, (0, 1), t2, (2, 1, 3, 4), (0, 2, 4, 3))
    del x56
    x58 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x58 += einsum(x40, (0, 1, 2, 3), (0, 1, 2, 3))
    del x40
    x58 += einsum(x30, (0, 1, 2, 3), (0, 1, 2, 3))
    del x30
    x58 += einsum(x42, (0, 1, 2, 3), (0, 1, 2, 3))
    del x42
    x58 += einsum(x43, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x43
    x58 += einsum(x45, (0, 1, 2, 3), (1, 0, 2, 3))
    del x45
    x58 += einsum(x55, (0, 1, 2, 3), (0, 1, 3, 2))
    del x55
    x58 += einsum(x57, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x57
    t2new += einsum(x58, (0, 1, 2, 3), (0, 1, 3, 2))
    t2new += einsum(x58, (0, 1, 2, 3), (1, 0, 2, 3))
    del x58
    x59 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x59 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1)) * -0.5
    x59 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x60 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x60 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x60 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x60 += einsum(t2, (0, 1, 2, 3), x59, (1, 4, 3, 5), (0, 4, 2, 5)) * 4.0
    del x59
    t2new += einsum(t2, (0, 1, 2, 3), x60, (4, 1, 5, 3), (4, 0, 5, 2))
    del x60
    x61 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x61 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x61 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    t2new += einsum(v.vvvv, (0, 1, 2, 3), x61, (4, 5, 3, 1), (5, 4, 0, 2))
    x62 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x62 += einsum(v.oooo, (0, 1, 2, 3), (0, 1, 2, 3))
    x62 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 5, 3), (4, 0, 1, 5))
    t2new += einsum(x61, (0, 1, 2, 3), x62, (0, 4, 5, 1), (5, 4, 3, 2))
    del x61, x62
    x63 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x63 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x63 += einsum(t1, (0, 1), x12, (2, 3, 0, 4), (3, 2, 4, 1))
    del x12
    t2new += einsum(t1, (0, 1), x63, (2, 3, 0, 4), (2, 3, 1, 4))
    del x63
    x64 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x64 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x64 += einsum(x13, (0, 1, 2, 3), (0, 1, 2, 3))
    del x13
    t2new += einsum(t2, (0, 1, 2, 3), x64, (4, 1, 5, 2), (4, 0, 5, 3))
    del x64
    x65 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x65 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x65 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    t2new += einsum(t2, (0, 1, 2, 3), x65, (4, 1, 5, 2), (4, 0, 3, 5))
    del x65

    return {"t1new": t1new, "t2new": t2new}

def update_lams(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    # L amplitudes
    l1new = np.zeros((nvir, nocc), dtype=np.float64)
    l1new += einsum(f.ov, (0, 1), (1, 0))
    l2new = np.zeros((nvir, nvir, nocc, nocc), dtype=np.float64)
    l2new += einsum(l2, (0, 1, 2, 3), v.oooo, (4, 2, 5, 3), (0, 1, 4, 5))
    l2new += einsum(v.ovov, (0, 1, 2, 3), (1, 3, 0, 2))
    l2new += einsum(l2, (0, 1, 2, 3), v.vvvv, (4, 1, 5, 0), (4, 5, 3, 2))
    x0 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x0 += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    x1 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x1 += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 2, 5, 3), (0, 1, 4, 5))
    x2 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x2 += einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4))
    x3 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x3 += einsum(t1, (0, 1), x2, (2, 3, 4, 1), (2, 0, 3, 4))
    x4 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x4 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 5, 3), (0, 1, 4, 5))
    x5 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x5 += einsum(t1, (0, 1), v.ovov, (2, 3, 4, 1), (0, 2, 4, 3))
    x6 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x6 += einsum(t1, (0, 1), x5, (2, 3, 4, 1), (0, 2, 3, 4))
    x7 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x7 += einsum(x4, (0, 1, 2, 3), (1, 0, 3, 2))
    del x4
    x7 += einsum(x6, (0, 1, 2, 3), (0, 1, 2, 3))
    del x6
    l2new += einsum(l2, (0, 1, 2, 3), x7, (3, 2, 4, 5), (0, 1, 5, 4))
    x8 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x8 += einsum(t1, (0, 1), x7, (2, 3, 0, 4), (2, 3, 4, 1)) * 2.0
    del x7
    x9 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x9 += einsum(x1, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x1
    x9 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x3
    x9 += einsum(x8, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x8
    x10 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x10 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1))
    x10 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x11 = np.zeros((nocc, nvir), dtype=np.float64)
    x11 += einsum(t1, (0, 1), x10, (0, 2, 3, 1), (2, 3))
    x12 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x12 += einsum(x11, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4)) * 2.0
    x13 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x13 += einsum(v.ooov, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x13 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x13 += einsum(x5, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x13 += einsum(x5, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x14 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x14 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x14 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x15 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x15 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x15 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x16 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x16 += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), (0, 2, 3, 4))
    x17 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x17 += einsum(v.oooo, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x17 += einsum(v.oooo, (0, 1, 2, 3), (0, 1, 2, 3))
    x17 += einsum(x16, (0, 1, 2, 3), (2, 1, 0, 3))
    x17 += einsum(x16, (0, 1, 2, 3), (3, 2, 0, 1)) * -0.5
    x18 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x18 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * -2.0
    x18 += einsum(v.ooov, (0, 1, 2, 3), (2, 0, 1, 3))
    x18 += einsum(x0, (0, 1, 2, 3), (1, 2, 0, 3))
    x18 += einsum(x0, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    del x0
    x18 += einsum(x9, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x18 += einsum(x9, (0, 1, 2, 3), (1, 0, 2, 3)) * 0.5
    del x9
    x18 += einsum(x12, (0, 1, 2, 3), (1, 0, 2, 3))
    x18 += einsum(x12, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x12
    x18 += einsum(x13, (0, 1, 2, 3), x14, (1, 4, 5, 3), (0, 4, 2, 5)) * -2.0
    x18 += einsum(t1, (0, 1), x15, (2, 3, 1, 4), (0, 3, 2, 4)) * -1.0
    del x15
    x18 += einsum(t1, (0, 1), x17, (0, 2, 3, 4), (3, 2, 4, 1)) * 2.0
    del x17
    l1new += einsum(l2, (0, 1, 2, 3), x18, (2, 3, 4, 1), (0, 4))
    del x18
    x19 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x19 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x19 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x20 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x20 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x20 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x21 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x21 += einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    x22 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x22 += einsum(x21, (0, 1, 2, 3), (0, 1, 2, 3))
    x22 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    l1new += einsum(v.oovv, (0, 1, 2, 3), x22, (4, 0, 1, 3), (2, 4)) * -2.0
    x23 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x23 += einsum(l2, (0, 1, 2, 3), x19, (3, 4, 1, 5), (2, 4, 0, 5)) * 2.0
    x23 += einsum(l2, (0, 1, 2, 3), x20, (2, 4, 1, 5), (3, 4, 0, 5))
    x23 += einsum(t1, (0, 1), x22, (0, 2, 3, 4), (2, 3, 1, 4)) * 2.0
    l1new += einsum(v.ovvv, (0, 1, 2, 3), x23, (4, 0, 3, 2), (1, 4)) * -1.0
    del x23
    x24 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x24 += einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    x25 = np.zeros((nvir, nvir, nvir, nvir), dtype=np.float64)
    x25 += einsum(v.vvvv, (0, 1, 2, 3), (0, 2, 1, 3))
    x25 += einsum(v.vvvv, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    l1new += einsum(x24, (0, 1, 2, 3), x25, (1, 3, 4, 2), (4, 0)) * 2.0
    del x24, x25
    x26 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x26 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -0.5
    x26 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    x27 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x27 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x27 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x28 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x28 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * 0.5
    x28 += einsum(x26, (0, 1, 2, 3), x27, (0, 4, 2, 5), (1, 4, 3, 5)) * -1.0
    del x26, x27
    l1new += einsum(v.ovvv, (0, 1, 2, 3), x28, (4, 0, 3, 1), (2, 4)) * -2.0
    del x28
    x29 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x29 += einsum(v.ooov, (0, 1, 2, 3), (0, 1, 2, 3))
    x29 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x29 += einsum(x5, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x29 += einsum(x5, (0, 1, 2, 3), (0, 2, 1, 3))
    x30 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x30 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x30 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x31 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x31 += einsum(x16, (0, 1, 2, 3), (0, 2, 1, 3))
    x31 += einsum(x16, (0, 1, 2, 3), (0, 3, 2, 1)) * -0.5
    x32 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x32 += einsum(t2, (0, 1, 2, 3), x29, (4, 5, 1, 3), (4, 0, 5, 2)) * 2.0
    del x29
    x32 += einsum(t2, (0, 1, 2, 3), x13, (4, 5, 1, 2), (4, 0, 5, 3))
    del x13
    x32 += einsum(t1, (0, 1), x30, (2, 3, 1, 4), (0, 3, 2, 4)) * -1.0
    del x30
    x32 += einsum(t1, (0, 1), x31, (2, 3, 4, 0), (2, 4, 3, 1)) * 2.0
    del x31
    l1new += einsum(l2, (0, 1, 2, 3), x32, (3, 2, 4, 1), (0, 4))
    del x32
    x33 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x33 += einsum(x21, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x33 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x34 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x34 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    x34 += einsum(t1, (0, 1), x33, (2, 0, 3, 4), (2, 3, 4, 1)) * -0.5
    l1new += einsum(v.ovvv, (0, 1, 2, 3), x34, (4, 0, 3, 1), (2, 4)) * 2.0
    del x34
    x35 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x35 += einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    x36 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x36 += einsum(t1, (0, 1), x21, (2, 3, 4, 1), (3, 2, 4, 0))
    l2new += einsum(v.ovov, (0, 1, 2, 3), x36, (4, 5, 0, 2), (3, 1, 5, 4))
    x37 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x37 += einsum(t1, (0, 1), x36, (0, 2, 3, 4), (2, 4, 3, 1))
    x38 = np.zeros((nocc, nocc), dtype=np.float64)
    x38 += einsum(l2, (0, 1, 2, 3), x19, (2, 4, 0, 1), (3, 4))
    x39 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x39 += einsum(x35, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x39 += einsum(x35, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x35
    x39 += einsum(x21, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x39 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    x39 += einsum(x37, (0, 1, 2, 3), (0, 1, 2, 3))
    x39 += einsum(x37, (0, 1, 2, 3), (0, 2, 1, 3)) * -2.0
    del x37
    x39 += einsum(x14, (0, 1, 2, 3), x22, (0, 4, 5, 3), (4, 1, 5, 2)) * 4.0
    x39 += einsum(t1, (0, 1), x38, (2, 3), (2, 0, 3, 1)) * 4.0
    l1new += einsum(v.ovov, (0, 1, 2, 3), x39, (4, 0, 2, 1), (3, 4)) * -1.0
    del x39
    x40 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x40 += einsum(l2, (0, 1, 2, 3), t2, (4, 5, 1, 0), (3, 2, 4, 5))
    l2new += einsum(v.ovov, (0, 1, 2, 3), x40, (4, 5, 0, 2), (1, 3, 4, 5))
    x41 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x41 += einsum(t1, (0, 1), x40, (2, 0, 3, 4), (2, 3, 4, 1))
    x42 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x42 += einsum(x21, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x42 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    x43 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x43 += einsum(x41, (0, 1, 2, 3), (0, 1, 2, 3))
    x43 += einsum(x41, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    del x41
    x43 += einsum(t2, (0, 1, 2, 3), x22, (1, 4, 5, 3), (4, 0, 5, 2))
    del x22
    x43 += einsum(t2, (0, 1, 2, 3), x42, (1, 4, 5, 2), (4, 0, 5, 3)) * 0.5
    x43 += einsum(t1, (0, 1), x38, (2, 3), (2, 0, 3, 1))
    del x38
    l1new += einsum(v.ovov, (0, 1, 2, 3), x43, (4, 0, 2, 3), (1, 4)) * 2.0
    del x43
    x44 = np.zeros((nvir, nvir), dtype=np.float64)
    x44 += einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    x44 += einsum(l2, (0, 1, 2, 3), x14, (2, 3, 1, 4), (0, 4)) * 2.0
    x45 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x45 += einsum(v.ovvv, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x45 += einsum(v.ovvv, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    l1new += einsum(x44, (0, 1), x45, (2, 3, 1, 0), (3, 2))
    del x44, x45
    x46 = np.zeros((nocc, nocc), dtype=np.float64)
    x46 += einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    l1new += einsum(x11, (0, 1), x46, (2, 0), (1, 2)) * -2.0
    x47 = np.zeros((nocc, nocc), dtype=np.float64)
    x47 += einsum(l2, (0, 1, 2, 3), x19, (2, 4, 0, 1), (3, 4)) * 2.0
    x48 = np.zeros((nocc, nocc), dtype=np.float64)
    x48 += einsum(x46, (0, 1), (0, 1))
    del x46
    x48 += einsum(x47, (0, 1), (0, 1))
    del x47
    l1new += einsum(f.ov, (0, 1), x48, (2, 0), (1, 2)) * -1.0
    x49 = np.zeros((nocc, nvir), dtype=np.float64)
    x49 += einsum(t1, (0, 1), (0, 1)) * -1.0
    x49 += einsum(x14, (0, 1, 2, 3), x21, (0, 1, 4, 3), (4, 2)) * 2.0
    x49 += einsum(l1, (0, 1), x20, (1, 2, 3, 0), (2, 3)) * -1.0
    x49 += einsum(t1, (0, 1), x48, (0, 2), (2, 1))
    x50 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x50 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1)) * 2.0
    x50 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    l1new += einsum(x49, (0, 1), x50, (0, 2, 3, 1), (3, 2)) * -1.0
    del x49, x50
    x51 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x51 += einsum(x40, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x51 += einsum(x40, (0, 1, 2, 3), (1, 0, 3, 2))
    del x40
    x51 += einsum(x36, (0, 1, 2, 3), (2, 1, 0, 3))
    x51 += einsum(x36, (0, 1, 2, 3), (3, 1, 0, 2)) * -0.5
    del x36
    l1new += einsum(v.ooov, (0, 1, 2, 3), x51, (1, 4, 0, 2), (3, 4)) * 2.0
    del x51
    x52 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x52 += einsum(v.ooov, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x52 += einsum(v.ooov, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    l1new += einsum(x48, (0, 1), x52, (0, 2, 1, 3), (3, 2)) * -1.0
    del x52
    x53 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x53 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x53 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    l1new += einsum(l1, (0, 1), x53, (1, 2, 0, 3), (3, 2)) * 2.0
    del x53
    x54 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x54 += einsum(v.ovvv, (0, 1, 2, 3), (0, 1, 2, 3))
    x54 += einsum(v.ovvv, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x55 = np.zeros((nvir, nvir), dtype=np.float64)
    x55 += einsum(f.vv, (0, 1), (0, 1))
    x55 += einsum(t1, (0, 1), x54, (0, 1, 2, 3), (3, 2)) * 2.0
    del x54
    l1new += einsum(l1, (0, 1), x55, (0, 2), (2, 1))
    del x55
    x56 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x56 += einsum(v.ooov, (0, 1, 2, 3), (0, 1, 2, 3))
    x56 += einsum(v.ooov, (0, 1, 2, 3), (2, 0, 1, 3)) * -0.5
    x57 = np.zeros((nocc, nvir), dtype=np.float64)
    x57 += einsum(t1, (0, 1), x10, (0, 2, 3, 1), (2, 3)) * 2.0
    del x10
    x58 = np.zeros((nocc, nvir), dtype=np.float64)
    x58 += einsum(f.ov, (0, 1), (0, 1))
    x58 += einsum(x57, (0, 1), (0, 1))
    x59 = np.zeros((nocc, nocc), dtype=np.float64)
    x59 += einsum(f.oo, (0, 1), (0, 1))
    x59 += einsum(v.ovov, (0, 1, 2, 3), x14, (2, 4, 1, 3), (4, 0)) * 2.0
    x59 += einsum(t1, (0, 1), x56, (2, 3, 0, 1), (3, 2)) * 2.0
    x59 += einsum(t1, (0, 1), x58, (2, 1), (0, 2))
    del x58
    l1new += einsum(l1, (0, 1), x59, (1, 2), (0, 2)) * -1.0
    del x59
    x60 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x60 += einsum(l1, (0, 1), v.ooov, (2, 1, 3, 4), (2, 3, 0, 4))
    x61 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x61 += einsum(v.ooov, (0, 1, 2, 3), x21, (4, 1, 2, 5), (4, 0, 5, 3))
    x62 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x62 += einsum(v.ovvv, (0, 1, 2, 3), x21, (4, 5, 0, 3), (5, 4, 1, 2))
    x63 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x63 += einsum(x21, (0, 1, 2, 3), x5, (1, 2, 4, 5), (0, 4, 3, 5))
    x64 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x64 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 3, 1)) * -0.5
    x64 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x65 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x65 += einsum(x19, (0, 1, 2, 3), x64, (0, 4, 2, 5), (1, 4, 3, 5)) * 4.0
    del x64
    x66 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x66 += einsum(v.ovvv, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x66 += einsum(v.ovvv, (0, 1, 2, 3), (0, 2, 1, 3))
    x67 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x67 += einsum(t1, (0, 1), x66, (2, 1, 3, 4), (0, 2, 3, 4)) * 2.0
    del x66
    x68 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x68 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x68 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x68 += einsum(x65, (0, 1, 2, 3), (0, 1, 2, 3))
    del x65
    x68 += einsum(x67, (0, 1, 2, 3), (0, 1, 3, 2))
    del x67
    x69 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x69 += einsum(l2, (0, 1, 2, 3), x68, (3, 4, 1, 5), (2, 4, 0, 5))
    del x68
    x70 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x70 += einsum(t1, (0, 1), v.ovvv, (2, 3, 4, 1), (0, 2, 3, 4))
    x71 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x71 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5))
    x72 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x72 += einsum(v.ovov, (0, 1, 2, 3), x20, (2, 4, 5, 3), (0, 4, 1, 5))
    del x20
    x73 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x73 += einsum(v.ovov, (0, 1, 2, 3), (0, 2, 1, 3))
    x73 += einsum(x70, (0, 1, 2, 3), (0, 1, 3, 2))
    del x70
    x73 += einsum(x71, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x71
    x73 += einsum(x72, (0, 1, 2, 3), (1, 0, 3, 2))
    del x72
    x74 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x74 += einsum(l2, (0, 1, 2, 3), x73, (2, 4, 1, 5), (3, 4, 0, 5))
    del x73
    x75 = np.zeros((nvir, nvir), dtype=np.float64)
    x75 += einsum(v.ovov, (0, 1, 2, 3), x19, (0, 2, 1, 4), (3, 4)) * 2.0
    del x19
    x76 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x76 += einsum(v.ovvv, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x76 += einsum(v.ovvv, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x77 = np.zeros((nvir, nvir), dtype=np.float64)
    x77 += einsum(t1, (0, 1), x76, (0, 2, 1, 3), (2, 3))
    del x76
    x78 = np.zeros((nvir, nvir), dtype=np.float64)
    x78 += einsum(x75, (0, 1), (0, 1))
    del x75
    x78 += einsum(x77, (0, 1), (0, 1)) * -1.0
    del x77
    x79 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x79 += einsum(x78, (0, 1), l2, (2, 1, 3, 4), (4, 3, 2, 0))
    del x78
    x80 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x80 += einsum(v.ooov, (0, 1, 2, 3), x33, (4, 0, 1, 5), (2, 4, 3, 5))
    del x33
    x81 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x81 += einsum(x42, (0, 1, 2, 3), x5, (0, 4, 2, 5), (4, 1, 5, 3))
    del x42
    x82 = np.zeros((nocc, nocc), dtype=np.float64)
    x82 += einsum(v.ovov, (0, 1, 2, 3), x14, (2, 4, 1, 3), (0, 4))
    x83 = np.zeros((nocc, nocc), dtype=np.float64)
    x83 += einsum(t1, (0, 1), x56, (2, 3, 0, 1), (2, 3))
    del x56
    x84 = np.zeros((nocc, nocc), dtype=np.float64)
    x84 += einsum(t1, (0, 1), x11, (2, 1), (0, 2))
    x85 = np.zeros((nocc, nocc), dtype=np.float64)
    x85 += einsum(x82, (0, 1), (1, 0))
    del x82
    x85 += einsum(x83, (0, 1), (1, 0))
    del x83
    x85 += einsum(x84, (0, 1), (0, 1))
    del x84
    x86 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x86 += einsum(x85, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3)) * 2.0
    del x85
    x87 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x87 += einsum(x11, (0, 1), x21, (2, 3, 0, 4), (2, 3, 4, 1)) * 2.0
    del x11
    x88 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x88 += einsum(f.ov, (0, 1), l1, (2, 3), (0, 3, 1, 2)) * -1.0
    x88 += einsum(x60, (0, 1, 2, 3), (0, 1, 2, 3))
    del x60
    x88 += einsum(x61, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x61
    x88 += einsum(x62, (0, 1, 2, 3), (0, 1, 2, 3))
    del x62
    x88 += einsum(x63, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x63
    x88 += einsum(x69, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x69
    x88 += einsum(x74, (0, 1, 2, 3), (0, 1, 2, 3))
    del x74
    x88 += einsum(x79, (0, 1, 2, 3), (1, 0, 2, 3))
    del x79
    x88 += einsum(x80, (0, 1, 2, 3), (1, 0, 3, 2))
    del x80
    x88 += einsum(x81, (0, 1, 2, 3), (1, 0, 3, 2))
    del x81
    x88 += einsum(x86, (0, 1, 2, 3), (0, 1, 3, 2))
    del x86
    x88 += einsum(x87, (0, 1, 2, 3), (0, 1, 2, 3))
    del x87
    x88 += einsum(l1, (0, 1), x57, (2, 3), (1, 2, 0, 3)) * -1.0
    del x57
    l2new += einsum(x88, (0, 1, 2, 3), (2, 3, 0, 1)) * -1.0
    l2new += einsum(x88, (0, 1, 2, 3), (3, 2, 1, 0)) * -1.0
    del x88
    x89 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x89 += einsum(f.vv, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    x90 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x90 += einsum(l1, (0, 1), v.ovvv, (2, 3, 4, 0), (1, 2, 3, 4))
    x91 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x91 += einsum(f.ov, (0, 1), x21, (2, 3, 0, 4), (2, 3, 1, 4))
    x92 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x92 += einsum(l1, (0, 1), x5, (1, 2, 3, 4), (2, 3, 0, 4))
    x93 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x93 += einsum(l2, (0, 1, 2, 3), x16, (2, 4, 3, 5), (4, 5, 0, 1))
    del x16
    x94 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x94 += einsum(v.ooov, (0, 1, 2, 3), x21, (1, 4, 2, 5), (4, 0, 5, 3))
    x95 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x95 += einsum(x21, (0, 1, 2, 3), x5, (0, 2, 4, 5), (1, 4, 3, 5))
    del x5, x21
    x96 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x96 += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 2, 1, 5), (0, 4, 3, 5))
    x97 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x97 += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3))
    x97 += einsum(x2, (0, 1, 2, 3), (0, 1, 3, 2))
    del x2
    x97 += einsum(x96, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x96
    x98 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x98 += einsum(l2, (0, 1, 2, 3), x97, (2, 4, 1, 5), (3, 4, 0, 5))
    del x97
    x99 = np.zeros((nvir, nvir), dtype=np.float64)
    x99 += einsum(l2, (0, 1, 2, 3), x14, (2, 3, 1, 4), (0, 4))
    del x14
    x100 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x100 += einsum(x99, (0, 1), v.ovov, (2, 1, 3, 4), (2, 3, 4, 0)) * 2.0
    del x99
    x101 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x101 += einsum(x48, (0, 1), v.ovov, (2, 3, 1, 4), (2, 0, 4, 3))
    del x48
    x102 = np.zeros((nocc, nocc), dtype=np.float64)
    x102 += einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    x103 = np.zeros((nocc, nocc), dtype=np.float64)
    x103 += einsum(f.oo, (0, 1), (0, 1))
    x103 += einsum(x102, (0, 1), (1, 0))
    del x102
    x104 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x104 += einsum(x103, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del x103
    x105 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x105 += einsum(x89, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x89
    x105 += einsum(x90, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x90
    x105 += einsum(x91, (0, 1, 2, 3), (0, 1, 2, 3))
    del x91
    x105 += einsum(x92, (0, 1, 2, 3), (0, 1, 2, 3))
    del x92
    x105 += einsum(x93, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x93
    x105 += einsum(x94, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x94
    x105 += einsum(x95, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x95
    x105 += einsum(x98, (0, 1, 2, 3), (0, 1, 2, 3))
    del x98
    x105 += einsum(x100, (0, 1, 2, 3), (1, 0, 3, 2))
    del x100
    x105 += einsum(x101, (0, 1, 2, 3), (1, 0, 3, 2))
    del x101
    x105 += einsum(x104, (0, 1, 2, 3), (1, 0, 3, 2))
    del x104
    l2new += einsum(x105, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    l2new += einsum(x105, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    del x105

    return {"l1new": l1new, "l2new": l2new}

def make_rdm1_f(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    delta = Namespace(oo=np.eye(nocc), vv=np.eye(nvir))

    # RDM1
    rdm1_f_oo = np.zeros((nocc, nocc), dtype=np.float64)
    rdm1_f_oo += einsum(delta.oo, (0, 1), (0, 1)) * 2.0
    rdm1_f_ov = np.zeros((nocc, nvir), dtype=np.float64)
    rdm1_f_ov += einsum(t1, (0, 1), (0, 1)) * 2.0
    rdm1_f_vo = np.zeros((nvir, nocc), dtype=np.float64)
    rdm1_f_vo += einsum(l1, (0, 1), (0, 1)) * 2.0
    rdm1_f_vv = np.zeros((nvir, nvir), dtype=np.float64)
    rdm1_f_vv += einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 2.0
    x0 = np.zeros((nocc, nocc), dtype=np.float64)
    x0 += einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm1_f_oo += einsum(x0, (0, 1), (1, 0)) * -2.0
    x1 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x1 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x1 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    rdm1_f_oo += einsum(l2, (0, 1, 2, 3), x1, (2, 4, 0, 1), (4, 3)) * -2.0
    del x1
    x2 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x2 += einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    x3 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x3 += einsum(x2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x3 += einsum(x2, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x2
    rdm1_f_ov += einsum(t2, (0, 1, 2, 3), x3, (0, 1, 4, 2), (4, 3)) * -2.0
    del x3
    x4 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x4 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x4 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    rdm1_f_ov += einsum(l1, (0, 1), x4, (1, 2, 3, 0), (2, 3)) * 4.0
    x5 = np.zeros((nocc, nocc), dtype=np.float64)
    x5 += einsum(x0, (0, 1), (0, 1))
    del x0
    x5 += einsum(l2, (0, 1, 2, 3), x4, (3, 4, 0, 1), (2, 4)) * 2.0
    del x4
    rdm1_f_ov += einsum(t1, (0, 1), x5, (0, 2), (2, 1)) * -2.0
    del x5
    x6 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x6 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1))
    x6 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * -0.5
    rdm1_f_vv += einsum(t2, (0, 1, 2, 3), x6, (0, 1, 4, 2), (4, 3)) * 4.0
    del x6

    rdm1_f = np.block([[rdm1_f_oo, rdm1_f_ov], [rdm1_f_vo, rdm1_f_vv]])

    return rdm1_f

def make_rdm2_f(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    delta = Namespace(oo=np.eye(nocc), vv=np.eye(nvir))

    # RDM2
    rdm2_f_oooo = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_ovoo = np.zeros((nocc, nvir, nocc, nocc), dtype=np.float64)
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_vooo = np.zeros((nvir, nocc, nocc, nocc), dtype=np.float64)
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_oovv = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    rdm2_f_oovv += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovov = np.zeros((nocc, nvir, nocc, nvir), dtype=np.float64)
    rdm2_f_ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_ovvo = np.zeros((nocc, nvir, nvir, nocc), dtype=np.float64)
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_voov = np.zeros((nvir, nocc, nocc, nvir), dtype=np.float64)
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_vovo = np.zeros((nvir, nocc, nvir, nocc), dtype=np.float64)
    rdm2_f_vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_vvoo = np.zeros((nvir, nvir, nocc, nocc), dtype=np.float64)
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    x0 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x0 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x0 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x1 = np.zeros((nocc, nocc), dtype=np.float64)
    x1 += einsum(l2, (0, 1, 2, 3), x0, (3, 4, 0, 1), (2, 4))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 2, 1)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 1, 2)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 2, 1)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 1, 2)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    x2 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x2 += einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2_f_oooo += einsum(x2, (0, 1, 2, 3), (3, 2, 1, 0))
    rdm2_f_oooo += einsum(x2, (0, 1, 2, 3), (3, 2, 1, 0))
    x3 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x3 += einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 1, 0))
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 1, 0))
    x4 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x4 += einsum(t1, (0, 1), x3, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2_f_oooo += einsum(x4, (0, 1, 2, 3), (3, 2, 1, 0))
    rdm2_f_oooo += einsum(x4, (0, 1, 2, 3), (3, 2, 1, 0))
    x5 = np.zeros((nocc, nocc, nocc, nocc), dtype=np.float64)
    x5 += einsum(x2, (0, 1, 2, 3), (1, 0, 3, 2))
    x5 += einsum(x4, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (2, 3, 0, 1))
    x6 = np.zeros((nocc, nocc), dtype=np.float64)
    x6 += einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 1, 2))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 2, 1))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 1, 2))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 2, 1))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    x7 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x7 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x7 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3))
    x8 = np.zeros((nocc, nvir), dtype=np.float64)
    x8 += einsum(t2, (0, 1, 2, 3), x7, (0, 1, 4, 3), (4, 2)) * 2.0
    x9 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x9 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x9 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x10 = np.zeros((nocc, nvir), dtype=np.float64)
    x10 += einsum(l1, (0, 1), x9, (1, 2, 3, 0), (2, 3))
    x11 = np.zeros((nocc, nocc), dtype=np.float64)
    x11 += einsum(l2, (0, 1, 2, 3), x0, (3, 4, 0, 1), (2, 4)) * 2.0
    x12 = np.zeros((nocc, nocc), dtype=np.float64)
    x12 += einsum(x6, (0, 1), (0, 1))
    x12 += einsum(x11, (0, 1), (0, 1))
    rdm2_f_ooov = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    rdm2_f_ooov += einsum(t1, (0, 1), x12, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_ooov += einsum(t1, (0, 1), x12, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oovo = np.zeros((nocc, nocc, nvir, nocc), dtype=np.float64)
    rdm2_f_oovo += einsum(t1, (0, 1), x12, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oovo += einsum(t1, (0, 1), x12, (2, 3), (0, 3, 1, 2)) * -1.0
    x13 = np.zeros((nocc, nvir), dtype=np.float64)
    x13 += einsum(t1, (0, 1), x12, (0, 2), (2, 1))
    x14 = np.zeros((nocc, nvir), dtype=np.float64)
    x14 += einsum(x8, (0, 1), (0, 1))
    del x8
    x14 += einsum(x10, (0, 1), (0, 1)) * -1.0
    del x10
    x14 += einsum(x13, (0, 1), (0, 1))
    del x13
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x14, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x14, (2, 3), (2, 0, 1, 3))
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x14, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x14, (2, 3), (2, 0, 1, 3))
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x14, (2, 3), (0, 2, 3, 1))
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x14, (2, 3), (2, 0, 3, 1)) * -1.0
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x14, (2, 3), (0, 2, 3, 1))
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x14, (2, 3), (2, 0, 3, 1)) * -1.0
    del x14
    x15 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x15 += einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2_f_ooov += einsum(x15, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_ooov += einsum(x15, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_oovo += einsum(x15, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_oovo += einsum(x15, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    x16 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x16 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x16 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3))
    x17 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x17 += einsum(t2, (0, 1, 2, 3), x16, (1, 4, 5, 2), (4, 5, 0, 3))
    x18 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x18 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3))
    x18 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x19 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x19 += einsum(t2, (0, 1, 2, 3), x18, (1, 4, 5, 3), (4, 5, 0, 2)) * 2.0
    del x18
    x20 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x20 += einsum(t1, (0, 1), x5, (0, 2, 3, 4), (2, 3, 4, 1))
    del x5
    rdm2_f_ooov += einsum(x20, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_ooov += einsum(x20, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_oovo += einsum(x20, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_oovo += einsum(x20, (0, 1, 2, 3), (1, 2, 3, 0))
    x21 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x21 += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 1, 2, 3))
    x21 += einsum(x15, (0, 1, 2, 3), (1, 0, 2, 3))
    x21 += einsum(x17, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x21 += einsum(x19, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x21 += einsum(x20, (0, 1, 2, 3), (2, 0, 1, 3))
    del x20
    x21 += einsum(t1, (0, 1), x12, (2, 3), (0, 2, 3, 1))
    rdm2_f_ooov += einsum(x21, (0, 1, 2, 3), (0, 2, 1, 3))
    rdm2_f_ooov += einsum(x21, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(x21, (0, 1, 2, 3), (0, 2, 1, 3))
    rdm2_f_ooov += einsum(x21, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_oovo += einsum(x21, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_oovo += einsum(x21, (0, 1, 2, 3), (2, 0, 3, 1))
    rdm2_f_oovo += einsum(x21, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_oovo += einsum(x21, (0, 1, 2, 3), (2, 0, 3, 1))
    del x21
    x22 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x22 += einsum(t2, (0, 1, 2, 3), x3, (1, 4, 5, 2), (4, 5, 0, 3))
    rdm2_f_ooov += einsum(x22, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_ooov += einsum(x22, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_oovo += einsum(x22, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_oovo += einsum(x22, (0, 1, 2, 3), (2, 1, 3, 0))
    del x22
    x23 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x23 += einsum(t2, (0, 1, 2, 3), x3, (4, 1, 5, 2), (4, 5, 0, 3))
    rdm2_f_ooov += einsum(x23, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_ooov += einsum(x23, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_oovo += einsum(x23, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_oovo += einsum(x23, (0, 1, 2, 3), (1, 2, 3, 0))
    x24 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x24 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x24 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x25 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x25 += einsum(t2, (0, 1, 2, 3), x24, (1, 4, 5, 3), (4, 5, 0, 2))
    del x24
    rdm2_f_ooov += einsum(x25, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ooov += einsum(x25, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    del x25
    x26 = np.zeros((nocc, nvir), dtype=np.float64)
    x26 += einsum(t2, (0, 1, 2, 3), x7, (0, 1, 4, 3), (4, 2))
    del x7
    x27 = np.zeros((nocc, nvir), dtype=np.float64)
    x27 += einsum(l1, (0, 1), x9, (1, 2, 3, 0), (2, 3)) * 0.5
    x28 = np.zeros((nocc, nvir), dtype=np.float64)
    x28 += einsum(t1, (0, 1), x12, (0, 2), (2, 1)) * 0.5
    del x12
    x29 = np.zeros((nocc, nvir), dtype=np.float64)
    x29 += einsum(t1, (0, 1), (0, 1)) * -0.5
    x29 += einsum(x26, (0, 1), (0, 1))
    x29 += einsum(x27, (0, 1), (0, 1)) * -1.0
    x29 += einsum(x28, (0, 1), (0, 1))
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x29, (2, 3), (0, 2, 1, 3)) * -2.0
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x29, (2, 3), (0, 2, 1, 3)) * -2.0
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x29, (2, 3), (2, 0, 3, 1)) * -2.0
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x29, (2, 3), (2, 0, 3, 1)) * -2.0
    del x29
    x30 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x30 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x30 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    x31 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x31 += einsum(t2, (0, 1, 2, 3), x30, (4, 1, 5, 3), (4, 5, 0, 2))
    del x30
    rdm2_f_oovo += einsum(x31, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_oovo += einsum(x31, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x31
    x32 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x32 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x32 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_oovv += einsum(x32, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x32, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x32, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x32, (0, 1, 2, 3), (0, 1, 2, 3))
    x33 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x33 += einsum(t2, (0, 1, 2, 3), x4, (0, 1, 4, 5), (5, 4, 3, 2))
    rdm2_f_oovv += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    x34 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x34 += einsum(t1, (0, 1), x4, (0, 2, 3, 4), (2, 4, 3, 1))
    del x4
    x35 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x35 += einsum(t1, (0, 1), x34, (0, 2, 3, 4), (2, 3, 1, 4))
    del x34
    rdm2_f_oovv += einsum(x35, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x35, (0, 1, 2, 3), (0, 1, 2, 3))
    x36 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x36 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -0.5
    x36 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    x37 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x37 += einsum(t2, (0, 1, 2, 3), x36, (1, 4, 3, 5), (4, 0, 5, 2))
    x38 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x38 += einsum(t2, (0, 1, 2, 3), x37, (1, 4, 3, 5), (4, 0, 5, 2)) * 4.0
    del x37
    rdm2_f_oovv += einsum(x38, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x38, (0, 1, 2, 3), (0, 1, 2, 3))
    x39 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x39 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1))
    x39 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * -1.0
    x40 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x40 += einsum(t2, (0, 1, 2, 3), x39, (1, 4, 2, 5), (4, 0, 5, 3))
    del x39
    x41 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x41 += einsum(t2, (0, 1, 2, 3), x40, (1, 4, 2, 5), (4, 0, 5, 3)) * -1.0
    del x40
    x42 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x42 += einsum(x2, (0, 1, 2, 3), x32, (0, 1, 4, 5), (2, 3, 4, 5))
    del x2, x32
    rdm2_f_oovv += einsum(x42, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_oovv += einsum(x42, (0, 1, 2, 3), (1, 0, 3, 2))
    x43 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x43 += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    del x33
    x43 += einsum(x35, (0, 1, 2, 3), (0, 1, 2, 3))
    del x35
    x43 += einsum(x38, (0, 1, 2, 3), (1, 0, 3, 2))
    del x38
    x43 += einsum(x41, (0, 1, 2, 3), (0, 1, 2, 3))
    del x41
    x43 += einsum(x42, (0, 1, 2, 3), (1, 0, 3, 2))
    del x42
    rdm2_f_oovv += einsum(x43, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x43, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x43, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x43, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x43
    x44 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x44 += einsum(x6, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    x45 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x45 += einsum(t2, (0, 1, 2, 3), x36, (1, 4, 3, 5), (4, 0, 5, 2)) * 2.0
    del x36
    x46 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x46 += einsum(t2, (0, 1, 2, 3), x45, (1, 4, 2, 5), (4, 0, 5, 3))
    del x45
    x47 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x47 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1))
    x47 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * -0.5
    x48 = np.zeros((nvir, nvir), dtype=np.float64)
    x48 += einsum(t2, (0, 1, 2, 3), x47, (0, 1, 3, 4), (4, 2)) * 2.0
    x49 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x49 += einsum(x48, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4))
    x50 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x50 += einsum(x15, (0, 1, 2, 3), (0, 1, 2, 3))
    x50 += einsum(x17, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x17
    x50 += einsum(x19, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x19
    x51 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x51 += einsum(t1, (0, 1), x50, (0, 2, 3, 4), (2, 3, 4, 1))
    del x50
    x52 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x52 += einsum(x11, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del x11
    x53 = np.zeros((nocc, nvir), dtype=np.float64)
    x53 += einsum(x26, (0, 1), (0, 1))
    x53 += einsum(x27, (0, 1), (0, 1)) * -1.0
    x53 += einsum(x28, (0, 1), (0, 1))
    del x28
    x54 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x54 += einsum(x44, (0, 1, 2, 3), (0, 1, 2, 3))
    x54 += einsum(x46, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x54 += einsum(x49, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x54 += einsum(x51, (0, 1, 2, 3), (0, 1, 3, 2))
    del x51
    x54 += einsum(x52, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x54 += einsum(t1, (0, 1), x53, (2, 3), (0, 2, 1, 3)) * -2.0
    del x53
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 3, 2))
    del x54
    x55 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x55 += einsum(l2, (0, 1, 2, 3), t2, (4, 3, 1, 5), (2, 4, 0, 5))
    x56 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x56 += einsum(t2, (0, 1, 2, 3), x55, (1, 4, 2, 5), (0, 4, 3, 5))
    del x55
    rdm2_f_oovv += einsum(x56, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x56, (0, 1, 2, 3), (0, 1, 2, 3))
    del x56
    x57 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x57 += einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    rdm2_f_ovov += einsum(x57, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x57, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_vovo += einsum(x57, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x57, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    x58 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x58 += einsum(t2, (0, 1, 2, 3), x57, (1, 4, 2, 5), (0, 4, 3, 5))
    rdm2_f_oovv += einsum(x58, (0, 1, 2, 3), (0, 1, 3, 2))
    rdm2_f_oovv += einsum(x58, (0, 1, 2, 3), (0, 1, 3, 2))
    del x58
    x59 = np.zeros((nocc, nvir), dtype=np.float64)
    x59 += einsum(t1, (0, 1), x6, (0, 2), (2, 1))
    del x6
    rdm2_f_oovv += einsum(t1, (0, 1), x59, (2, 3), (2, 0, 3, 1)) * -1.0
    rdm2_f_oovv += einsum(t1, (0, 1), x59, (2, 3), (2, 0, 3, 1)) * -1.0
    x60 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x60 += einsum(t2, (0, 1, 2, 3), x3, (4, 1, 5, 3), (4, 5, 0, 2))
    x61 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x61 += einsum(x3, (0, 1, 2, 3), x9, (0, 4, 5, 3), (4, 1, 2, 5))
    x62 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x62 += einsum(x60, (0, 1, 2, 3), (0, 1, 2, 3))
    del x60
    x62 += einsum(x61, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    del x61
    x63 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x63 += einsum(t1, (0, 1), x62, (0, 2, 3, 4), (2, 3, 4, 1))
    del x62
    x64 = np.zeros((nocc, nvir), dtype=np.float64)
    x64 += einsum(t1, (0, 1), x1, (0, 2), (2, 1))
    del x1
    x65 = np.zeros((nocc, nvir), dtype=np.float64)
    x65 += einsum(x26, (0, 1), (0, 1))
    del x26
    x65 += einsum(x27, (0, 1), (0, 1)) * -1.0
    del x27
    x65 += einsum(x64, (0, 1), (0, 1))
    del x64
    x66 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x66 += einsum(x46, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x46
    x66 += einsum(x49, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x49
    x66 += einsum(x63, (0, 1, 2, 3), (0, 1, 3, 2))
    del x63
    x66 += einsum(x52, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x52
    x66 += einsum(t1, (0, 1), x65, (2, 3), (0, 2, 1, 3)) * -2.0
    del x65
    rdm2_f_oovv += einsum(x66, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x66, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_oovv += einsum(x66, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x66, (0, 1, 2, 3), (1, 0, 3, 2))
    del x66
    x67 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x67 += einsum(x15, (0, 1, 2, 3), (0, 1, 2, 3))
    del x15
    x67 += einsum(x23, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x23
    x68 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x68 += einsum(t1, (0, 1), x67, (0, 2, 3, 4), (2, 3, 4, 1))
    del x67
    x69 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x69 += einsum(x44, (0, 1, 2, 3), (0, 1, 2, 3))
    del x44
    x69 += einsum(x68, (0, 1, 2, 3), (0, 1, 3, 2))
    del x68
    rdm2_f_oovv += einsum(x69, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x69, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_oovv += einsum(x69, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x69, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x69
    x70 = np.zeros((nocc, nvir), dtype=np.float64)
    x70 += einsum(t1, (0, 1), (0, 1)) * -1.0
    x70 += einsum(x59, (0, 1), (0, 1))
    del x59
    rdm2_f_oovv += einsum(t1, (0, 1), x70, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_oovv += einsum(t1, (0, 1), x70, (2, 3), (0, 2, 1, 3)) * -1.0
    del x70
    x71 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x71 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x71 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x72 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x72 += einsum(l2, (0, 1, 2, 3), x71, (2, 4, 5, 1), (4, 3, 5, 0))
    rdm2_f_ovov += einsum(x72, (0, 1, 2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_ovov += einsum(x72, (0, 1, 2, 3), (0, 3, 1, 2)) * -1.0
    del x72
    x73 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x73 += einsum(l2, (0, 1, 2, 3), x0, (3, 4, 5, 1), (2, 4, 0, 5)) * 2.0
    del x0
    rdm2_f_ovov += einsum(x73, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x73, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x73, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_voov += einsum(x73, (0, 1, 2, 3), (2, 1, 0, 3))
    del x73
    x74 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x74 += einsum(t1, (0, 1), x16, (2, 0, 3, 4), (2, 3, 4, 1))
    del x16
    rdm2_f_ovov += einsum(x74, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x74, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_vovo += einsum(x74, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x74, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x74
    x75 = np.zeros((nvir, nvir), dtype=np.float64)
    x75 += einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    x76 = np.zeros((nvir, nvir), dtype=np.float64)
    x76 += einsum(x75, (0, 1), (0, 1))
    x76 += einsum(x48, (0, 1), (0, 1))
    del x48
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x76, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x76, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(delta.oo, (0, 1), x76, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_voov += einsum(delta.oo, (0, 1), x76, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x76, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x76, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x76, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x76, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvv = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    rdm2_f_ovvv += einsum(t1, (0, 1), x76, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovvv += einsum(t1, (0, 1), x76, (2, 3), (0, 2, 1, 3))
    rdm2_f_vovv = np.zeros((nvir, nocc, nvir, nvir), dtype=np.float64)
    rdm2_f_vovv += einsum(t1, (0, 1), x76, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovv += einsum(t1, (0, 1), x76, (2, 3), (2, 0, 3, 1))
    x77 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x77 += einsum(t1, (0, 1), x3, (0, 2, 3, 4), (2, 3, 4, 1))
    rdm2_f_ovov += einsum(x77, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x77, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_vovo += einsum(x77, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x77, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x77
    x78 = np.zeros((nvir, nvir), dtype=np.float64)
    x78 += einsum(t2, (0, 1, 2, 3), x47, (0, 1, 3, 4), (4, 2))
    del x47
    x79 = np.zeros((nvir, nvir), dtype=np.float64)
    x79 += einsum(x75, (0, 1), (0, 1)) * 0.5
    del x75
    x79 += einsum(x78, (0, 1), (0, 1))
    del x78
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x79, (2, 3), (0, 2, 1, 3)) * 2.0
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x79, (2, 3), (0, 2, 1, 3)) * 2.0
    rdm2_f_ovvo += einsum(delta.oo, (0, 1), x79, (2, 3), (0, 2, 3, 1)) * -2.0
    rdm2_f_ovvo += einsum(delta.oo, (0, 1), x79, (2, 3), (0, 2, 3, 1)) * -2.0
    del x79
    x80 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x80 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x80 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    x81 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x81 += einsum(t2, (0, 1, 2, 3), x80, (1, 4, 2, 5), (4, 0, 5, 3))
    del x80
    rdm2_f_ovvo += einsum(x81, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x81, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x81, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vovo += einsum(x81, (0, 1, 2, 3), (2, 1, 3, 0))
    del x81
    x82 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x82 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x82 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * 2.0
    x83 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x83 += einsum(t2, (0, 1, 2, 3), x82, (1, 4, 3, 5), (4, 0, 5, 2))
    del x82
    rdm2_f_ovvo += einsum(x83, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_ovvo += einsum(x83, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_vovo += einsum(x83, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x83, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x83
    x84 = np.zeros((nocc, nocc, nocc, nvir), dtype=np.float64)
    x84 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3))
    x84 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x85 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x85 += einsum(t1, (0, 1), x84, (2, 0, 3, 4), (2, 3, 4, 1))
    del x84
    rdm2_f_ovvo += einsum(x85, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x85, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_voov += einsum(x85, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x85, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    del x85
    x86 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x86 += einsum(l2, (0, 1, 2, 3), t2, (4, 2, 5, 1), (3, 4, 0, 5))
    rdm2_f_ovvo += einsum(x86, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x86, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_voov += einsum(x86, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x86, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    x87 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x87 += einsum(t1, (0, 1), x3, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2_f_ovvo += einsum(x87, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x87, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_voov += einsum(x87, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x87, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    x88 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x88 += einsum(l2, (0, 1, 2, 3), x9, (3, 4, 5, 1), (4, 2, 5, 0))
    del x9
    rdm2_f_ovvo += einsum(x88, (0, 1, 2, 3), (0, 3, 2, 1))
    rdm2_f_ovvo += einsum(x88, (0, 1, 2, 3), (0, 3, 2, 1))
    rdm2_f_voov += einsum(x88, (0, 1, 2, 3), (3, 0, 1, 2))
    rdm2_f_voov += einsum(x88, (0, 1, 2, 3), (3, 0, 1, 2))
    del x88
    x89 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x89 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x89 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x90 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x90 += einsum(l2, (0, 1, 2, 3), x89, (2, 4, 5, 1), (4, 3, 5, 0))
    del x89
    rdm2_f_voov += einsum(x90, (0, 1, 2, 3), (3, 0, 1, 2)) * -1.0
    rdm2_f_voov += einsum(x90, (0, 1, 2, 3), (3, 0, 1, 2)) * -1.0
    del x90
    x91 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x91 += einsum(l1, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2_f_ovvv += einsum(x91, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovvv += einsum(x91, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vovv += einsum(x91, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vovv += einsum(x91, (0, 1, 2, 3), (1, 0, 3, 2))
    x92 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x92 += einsum(t2, (0, 1, 2, 3), x3, (1, 0, 4, 5), (4, 5, 3, 2))
    del x3
    rdm2_f_ovvv += einsum(x92, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_ovvv += einsum(x92, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x92, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x92, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x93 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x93 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x93 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x94 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x94 += einsum(l2, (0, 1, 2, 3), x93, (3, 4, 1, 5), (4, 2, 5, 0))
    x95 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x95 += einsum(l2, (0, 1, 2, 3), x71, (2, 4, 1, 5), (4, 3, 5, 0))
    del x71
    x96 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x96 += einsum(x87, (0, 1, 2, 3), (0, 1, 2, 3))
    x96 += einsum(x94, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x96 += einsum(x95, (0, 1, 2, 3), (1, 0, 3, 2))
    del x95
    x97 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x97 += einsum(t1, (0, 1), x96, (0, 2, 3, 4), (2, 3, 4, 1))
    del x96
    x98 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x98 += einsum(x91, (0, 1, 2, 3), (0, 1, 2, 3))
    del x91
    x98 += einsum(x92, (0, 1, 2, 3), (0, 1, 2, 3))
    del x92
    x98 += einsum(x97, (0, 1, 2, 3), (0, 1, 3, 2))
    del x97
    x98 += einsum(t1, (0, 1), x76, (2, 3), (0, 2, 1, 3))
    del x76
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 3, 2))
    del x98
    x99 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x99 += einsum(t1, (0, 1), x57, (0, 2, 3, 4), (2, 3, 1, 4))
    del x57
    rdm2_f_ovvv += einsum(x99, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_ovvv += einsum(x99, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x99, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x99, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x99
    x100 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x100 += einsum(x86, (0, 1, 2, 3), (0, 1, 2, 3))
    x100 += einsum(x87, (0, 1, 2, 3), (0, 1, 2, 3))
    x100 += einsum(x94, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x94
    x101 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x101 += einsum(t1, (0, 1), x100, (0, 2, 3, 4), (2, 3, 4, 1))
    del x100
    rdm2_f_ovvv += einsum(x101, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_ovvv += einsum(x101, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x101
    x102 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x102 += einsum(l2, (0, 1, 2, 3), x93, (3, 4, 1, 5), (4, 2, 5, 0)) * 0.5
    del x93
    x103 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x103 += einsum(x86, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x86
    x103 += einsum(x87, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x87
    x103 += einsum(x102, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x102
    x104 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x104 += einsum(t1, (0, 1), x103, (0, 2, 3, 4), (2, 3, 4, 1)) * 2.0
    del x103
    rdm2_f_vovv += einsum(x104, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x104, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x104
    x105 = np.zeros((nocc, nvir, nvir, nvir), dtype=np.float64)
    x105 += einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2_f_vvov = np.zeros((nvir, nvir, nocc, nvir), dtype=np.float64)
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_vvvo = np.zeros((nvir, nvir, nvir, nocc), dtype=np.float64)
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    x106 = np.zeros((nvir, nvir, nvir, nvir), dtype=np.float64)
    x106 += einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2_f_vvvv = np.zeros((nvir, nvir, nvir, nvir), dtype=np.float64)
    rdm2_f_vvvv += einsum(x106, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vvvv += einsum(x106, (0, 1, 2, 3), (1, 0, 3, 2))
    x107 = np.zeros((nvir, nvir, nvir, nvir), dtype=np.float64)
    x107 += einsum(t1, (0, 1), x105, (0, 2, 3, 4), (3, 2, 4, 1))
    del x105
    rdm2_f_vvvv += einsum(x107, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vvvv += einsum(x107, (0, 1, 2, 3), (1, 0, 3, 2))
    x108 = np.zeros((nvir, nvir, nvir, nvir), dtype=np.float64)
    x108 += einsum(x106, (0, 1, 2, 3), (1, 0, 3, 2))
    del x106
    x108 += einsum(x107, (0, 1, 2, 3), (1, 0, 3, 2))
    del x107
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 2, 3))
    del x108

    rdm2_f = pack_2e(rdm2_f_oooo, rdm2_f_ooov, rdm2_f_oovo, rdm2_f_ovoo, rdm2_f_vooo, rdm2_f_oovv, rdm2_f_ovov, rdm2_f_ovvo, rdm2_f_voov, rdm2_f_vovo, rdm2_f_vvoo, rdm2_f_ovvv, rdm2_f_vovv, rdm2_f_vvov, rdm2_f_vvvo, rdm2_f_vvvv)

    rdm2_f = rdm2_f.swapaxes(1, 2)

    return rdm2_f

