# Code generated for ebcc.

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, Namespace

def energy(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, t3=None, t4=None, **kwargs):
    # energy
    e_cc = 0
    e_cc += einsum(t1, (0, 1), f.ov, (0, 1), ())
    x0 = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    x0 += einsum(t2, (0, 1, 2, 3), (1, 0, 3, 2))
    x0 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3)) * 2.0
    e_cc += einsum(v.oovv, (0, 1, 2, 3), x0, (0, 1, 2, 3), ()) * 0.25

    return e_cc

def update_amps(f=None, v=None, nocc=None, nvir=None, t1=None, t2=None, t3=None, t4=None, **kwargs):
    # T amplitudes
    t1new = np.zeros((nocc, nvir), dtype=np.float64)
    t1new += einsum(f.ov, (0, 1), (0, 1))
    t1new += einsum(f.oo, (0, 1), t1, (1, 2), (0, 2)) * -1.0
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 1), (2, 3))
    t1new += einsum(t1, (0, 1), v.ovov, (2, 1, 0, 3), (2, 3)) * -1.0
    t1new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 3), (4, 2)) * -0.5
    t1new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 2, 3), (0, 4)) * -0.5
    t1new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 2, 3), (4, 5)) * 0.25
    t1new += einsum(f.ov, (0, 1), t1, (2, 1), t1, (0, 3), (2, 3)) * -1.0
    t1new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 1), (4, 3))
    t1new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 3), (0, 4)) * -1.0
    t1new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 5), (0, 4)) * -0.5
    t1new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 4, 5), (2, 1)) * -0.5
    t1new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 5), (2, 4))
    t1new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 3), (0, 5))
    t2new = np.zeros((nocc, nocc, nvir, nvir), dtype=np.float64)
    t2new += einsum(v.oovv, (0, 1, 2, 3), (0, 1, 2, 3))
    t2new += einsum(f.oo, (0, 1), t2, (2, 1, 3, 4), (0, 2, 3, 4))
    t2new += einsum(f.oo, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4)) * -1.0
    t2new += einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4)) * -1.0
    t2new += einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 4, 0))
    t2new += einsum(t1, (0, 1), v.ooov, (2, 3, 0, 4), (2, 3, 1, 4)) * -1.0
    t2new += einsum(t1, (0, 1), v.ooov, (2, 3, 0, 4), (2, 3, 4, 1))
    t2new += einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (0, 2, 3, 4)) * -1.0
    t2new += einsum(t1, (0, 1), v.ovvv, (2, 1, 3, 4), (2, 0, 3, 4))
    t2new += einsum(f.ov, (0, 1), t3, (2, 3, 0, 4, 5, 1), (2, 3, 4, 5))
    t2new += einsum(t2, (0, 1, 2, 3), v.oooo, (4, 5, 0, 1), (4, 5, 2, 3)) * 0.5
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 2, 5)) * -1.0
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (0, 4, 5, 2))
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (4, 0, 2, 5))
    t2new += einsum(t2, (0, 1, 2, 3), v.ovov, (4, 3, 1, 5), (4, 0, 5, 2)) * -1.0
    t2new += einsum(t2, (0, 1, 2, 3), v.vvvv, (4, 5, 2, 3), (0, 1, 4, 5)) * 0.5
    t2new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 3), (2, 4, 5, 6)) * 0.5
    t2new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 3), (4, 2, 5, 6)) * -0.5
    t2new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), (4, 5, 1, 6)) * 0.5
    t2new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), (4, 5, 6, 1)) * -0.5
    t2new += einsum(v.oovv, (0, 1, 2, 3), t4, (4, 5, 0, 1, 6, 7, 2, 3), (4, 5, 6, 7)) * 0.25
    t2new += einsum(f.ov, (0, 1), t1, (2, 1), t2, (3, 0, 4, 5), (2, 3, 4, 5))
    t2new += einsum(f.ov, (0, 1), t1, (2, 1), t2, (3, 0, 4, 5), (3, 2, 4, 5)) * -1.0
    t2new += einsum(f.ov, (0, 1), t1, (0, 2), t2, (3, 4, 5, 1), (3, 4, 2, 5))
    t2new += einsum(f.ov, (0, 1), t1, (0, 2), t2, (3, 4, 5, 1), (3, 4, 5, 2)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), v.oooo, (4, 5, 0, 2), (4, 5, 1, 3))
    t2new += einsum(t1, (0, 1), t1, (2, 3), v.ovov, (4, 1, 2, 5), (0, 4, 3, 5))
    t2new += einsum(t1, (0, 1), t1, (2, 3), v.ovov, (4, 1, 2, 5), (0, 4, 5, 3)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), v.ovov, (4, 1, 2, 5), (4, 0, 3, 5)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), v.ovov, (4, 1, 2, 5), (4, 0, 5, 3))
    t2new += einsum(t1, (0, 1), t1, (2, 3), v.vvvv, (4, 5, 1, 3), (0, 2, 4, 5))
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (2, 3, 6, 1), (0, 6, 4, 5)) * -0.5
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (2, 3, 6, 1), (6, 0, 4, 5)) * 0.5
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (0, 3, 6, 5), (2, 6, 1, 4))
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (0, 3, 6, 5), (6, 2, 1, 4)) * -1.0
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (0, 3, 6, 5), (2, 6, 4, 1)) * -1.0
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (0, 3, 6, 5), (6, 2, 4, 1))
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (0, 3, 6, 1), (2, 6, 4, 5))
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ooov, (0, 3, 6, 1), (6, 2, 4, 5)) * -1.0
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (3, 6, 1, 5), (0, 2, 6, 4)) * -1.0
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (3, 6, 1, 5), (0, 2, 4, 6))
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (3, 6, 1, 5), (2, 0, 6, 4))
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (3, 6, 1, 5), (2, 0, 4, 6)) * -1.0
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (0, 6, 4, 5), (2, 3, 1, 6)) * -0.5
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (0, 6, 4, 5), (2, 3, 6, 1)) * 0.5
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (0, 6, 1, 5), (2, 3, 6, 4)) * -1.0
    t2new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovvv, (0, 6, 1, 5), (2, 3, 4, 6))
    t2new += einsum(t1, (0, 1), v.oovv, (2, 3, 1, 4), t3, (5, 2, 3, 6, 7, 4), (0, 5, 6, 7)) * 0.5
    t2new += einsum(t1, (0, 1), v.oovv, (2, 3, 1, 4), t3, (5, 2, 3, 6, 7, 4), (5, 0, 6, 7)) * -0.5
    t2new += einsum(t1, (0, 1), v.oovv, (0, 2, 3, 4), t3, (5, 6, 2, 7, 3, 4), (5, 6, 1, 7)) * 0.5
    t2new += einsum(t1, (0, 1), v.oovv, (0, 2, 3, 4), t3, (5, 6, 2, 7, 3, 4), (5, 6, 7, 1)) * -0.5
    t2new += einsum(t1, (0, 1), v.oovv, (0, 2, 1, 3), t3, (4, 5, 2, 6, 7, 3), (4, 5, 6, 7))
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (1, 5, 3, 7), (0, 4, 2, 6))
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (1, 5, 6, 7), (0, 4, 2, 3)) * -0.5
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (1, 5, 3, 7), (0, 4, 6, 2)) * -1.0
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (1, 5, 2, 3), (0, 4, 6, 7)) * -0.5
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (4, 5, 3, 7), (0, 1, 2, 6)) * -0.5
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (4, 5, 3, 7), (0, 1, 6, 2)) * 0.5
    t2new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oovv, (4, 5, 2, 3), (0, 1, 6, 7)) * 0.25
    t2new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.ooov, (2, 4, 6, 1), (0, 6, 3, 5)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.ooov, (2, 4, 6, 1), (6, 0, 3, 5))
    t2new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.ovvv, (4, 6, 1, 3), (0, 2, 5, 6)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.ovvv, (4, 6, 1, 3), (0, 2, 6, 5))
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (4, 5, 1, 3), (0, 2, 6, 7)) * 0.5
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (2, 5, 1, 7), (0, 4, 3, 6)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (2, 5, 1, 7), (0, 4, 6, 3))
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (2, 5, 1, 3), (0, 4, 6, 7)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (2, 5, 1, 7), (4, 0, 3, 6))
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (2, 5, 1, 7), (4, 0, 6, 3)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (2, 5, 1, 3), (4, 0, 6, 7))
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (0, 2, 6, 7), (4, 5, 1, 3)) * 0.5
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (0, 2, 1, 7), (4, 5, 3, 6))
    t2new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.oovv, (0, 2, 1, 7), (4, 5, 6, 3)) * -1.0
    t2new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t1, (6, 7), v.oovv, (4, 6, 1, 3), (0, 2, 5, 7))
    t3new = np.zeros((nocc, nocc, nocc, nvir, nvir, nvir), dtype=np.float64)
    t3new += einsum(f.oo, (0, 1), t3, (2, 3, 1, 4, 5, 6), (0, 2, 3, 4, 5, 6)) * -1.0
    t3new += einsum(f.oo, (0, 1), t3, (2, 3, 1, 4, 5, 6), (2, 0, 3, 4, 5, 6))
    t3new += einsum(f.oo, (0, 1), t3, (2, 3, 1, 4, 5, 6), (2, 3, 0, 4, 5, 6)) * -1.0
    t3new += einsum(f.vv, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 0, 5, 6))
    t3new += einsum(f.vv, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 5, 0, 6)) * -1.0
    t3new += einsum(f.vv, (0, 1), t3, (2, 3, 4, 5, 6, 1), (2, 3, 4, 5, 6, 0))
    t3new += einsum(f.ov, (0, 1), t4, (2, 3, 4, 0, 5, 6, 7, 1), (2, 3, 4, 5, 6, 7))
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (0, 4, 5, 2, 3, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (0, 4, 5, 2, 6, 3))
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (0, 4, 5, 6, 2, 3)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (4, 0, 5, 2, 3, 6))
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (4, 0, 5, 2, 6, 3)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (4, 0, 5, 6, 2, 3))
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (4, 5, 0, 2, 3, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (4, 5, 0, 2, 6, 3))
    t3new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 1, 6), (4, 5, 0, 6, 2, 3)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (0, 4, 1, 2, 5, 6))
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (0, 4, 1, 5, 2, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (0, 4, 1, 5, 6, 2))
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (0, 1, 4, 2, 5, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (0, 1, 4, 5, 2, 6))
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (0, 1, 4, 5, 6, 2)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (4, 0, 1, 2, 5, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (4, 0, 1, 5, 2, 6))
    t3new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 3, 5, 6), (4, 0, 1, 5, 6, 2)) * -1.0
    t3new += einsum(v.oooo, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 7), (0, 1, 4, 5, 6, 7)) * 0.5
    t3new += einsum(v.oooo, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 7), (0, 4, 1, 5, 6, 7)) * -0.5
    t3new += einsum(v.oooo, (0, 1, 2, 3), t3, (4, 2, 3, 5, 6, 7), (4, 0, 1, 5, 6, 7)) * 0.5
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (0, 4, 5, 3, 6, 7)) * -1.0
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (0, 4, 5, 6, 3, 7))
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (0, 4, 5, 6, 7, 3)) * -1.0
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 0, 5, 3, 6, 7))
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 0, 5, 6, 3, 7)) * -1.0
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 0, 5, 6, 7, 3))
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 5, 0, 3, 6, 7)) * -1.0
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 5, 0, 6, 3, 7))
    t3new += einsum(v.ovov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 1), (4, 5, 0, 6, 7, 3)) * -1.0
    t3new += einsum(v.vvvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), (4, 5, 6, 0, 1, 7)) * 0.5
    t3new += einsum(v.vvvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), (4, 5, 6, 0, 7, 1)) * -0.5
    t3new += einsum(v.vvvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), (4, 5, 6, 7, 0, 1)) * 0.5
    t3new += einsum(v.ooov, (0, 1, 2, 3), t4, (4, 5, 0, 1, 6, 7, 8, 3), (2, 4, 5, 6, 7, 8)) * -0.5
    t3new += einsum(v.ooov, (0, 1, 2, 3), t4, (4, 5, 0, 1, 6, 7, 8, 3), (4, 2, 5, 6, 7, 8)) * 0.5
    t3new += einsum(v.ooov, (0, 1, 2, 3), t4, (4, 5, 0, 1, 6, 7, 8, 3), (4, 5, 2, 6, 7, 8)) * -0.5
    t3new += einsum(v.ovvv, (0, 1, 2, 3), t4, (4, 5, 6, 0, 7, 8, 2, 3), (4, 5, 6, 1, 7, 8)) * -0.5
    t3new += einsum(v.ovvv, (0, 1, 2, 3), t4, (4, 5, 6, 0, 7, 8, 2, 3), (4, 5, 6, 7, 1, 8)) * 0.5
    t3new += einsum(v.ovvv, (0, 1, 2, 3), t4, (4, 5, 6, 0, 7, 8, 2, 3), (4, 5, 6, 7, 8, 1)) * -0.5
    t3new += einsum(f.ov, (0, 1), t1, (2, 1), t3, (3, 4, 0, 5, 6, 7), (2, 3, 4, 5, 6, 7)) * -1.0
    t3new += einsum(f.ov, (0, 1), t1, (2, 1), t3, (3, 4, 0, 5, 6, 7), (3, 2, 4, 5, 6, 7))
    t3new += einsum(f.ov, (0, 1), t1, (2, 1), t3, (3, 4, 0, 5, 6, 7), (3, 4, 2, 5, 6, 7)) * -1.0
    t3new += einsum(f.ov, (0, 1), t1, (0, 2), t3, (3, 4, 5, 6, 7, 1), (3, 4, 5, 2, 6, 7)) * -1.0
    t3new += einsum(f.ov, (0, 1), t1, (0, 2), t3, (3, 4, 5, 6, 7, 1), (3, 4, 5, 6, 2, 7))
    t3new += einsum(f.ov, (0, 1), t1, (0, 2), t3, (3, 4, 5, 6, 7, 1), (3, 4, 5, 6, 7, 2)) * -1.0
    t3new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t2, (5, 0, 6, 7), (2, 5, 3, 4, 6, 7)) * -1.0
    t3new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t2, (5, 0, 6, 7), (2, 5, 3, 6, 4, 7))
    t3new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t2, (5, 0, 6, 7), (2, 5, 3, 6, 7, 4)) * -1.0
    t3new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t2, (5, 6, 7, 1), (2, 5, 6, 3, 7, 4)) * -1.0
    t3new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t2, (5, 6, 7, 1), (2, 5, 6, 3, 4, 7))
    t3new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t2, (5, 6, 7, 1), (2, 5, 6, 7, 3, 4))
    t3new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t2, (5, 0, 6, 7), (2, 3, 5, 4, 6, 7))
    t3new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t2, (5, 0, 6, 7), (2, 3, 5, 6, 4, 7)) * -1.0
    t3new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t2, (5, 0, 6, 7), (2, 3, 5, 6, 7, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (2, 6, 7, 1, 4, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (6, 2, 7, 1, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (6, 7, 2, 1, 4, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (2, 6, 7, 4, 1, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (6, 2, 7, 4, 1, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (6, 7, 2, 4, 1, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (2, 6, 7, 4, 5, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (6, 2, 7, 4, 5, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oooo, (6, 7, 0, 3), (6, 7, 2, 4, 5, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (0, 2, 6, 4, 5, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (0, 2, 6, 4, 7, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (0, 2, 6, 7, 4, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (0, 6, 2, 4, 5, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (0, 6, 2, 4, 7, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (0, 6, 2, 7, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (2, 0, 6, 4, 5, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (2, 0, 6, 4, 7, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (2, 0, 6, 7, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (6, 0, 2, 4, 5, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (6, 0, 2, 4, 7, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (6, 0, 2, 7, 4, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (2, 6, 0, 4, 5, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (2, 6, 0, 4, 7, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (2, 6, 0, 7, 4, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (6, 2, 0, 4, 5, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (6, 2, 0, 4, 7, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 1, 3, 7), (6, 2, 0, 7, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 6, 3, 1, 4, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 6, 3, 1, 7, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 3, 6, 1, 4, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 3, 6, 1, 7, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (6, 2, 3, 1, 4, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (6, 2, 3, 1, 7, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 6, 3, 4, 1, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 6, 3, 7, 1, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 3, 6, 4, 1, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 3, 6, 7, 1, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (6, 2, 3, 4, 1, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (6, 2, 3, 7, 1, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 6, 3, 4, 7, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 6, 3, 7, 4, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 3, 6, 4, 7, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (2, 3, 6, 7, 4, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (6, 2, 3, 4, 7, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.ovov, (6, 5, 0, 7), (6, 2, 3, 7, 4, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (0, 2, 3, 6, 7, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (0, 2, 3, 6, 4, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (0, 2, 3, 4, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (2, 0, 3, 6, 7, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (2, 0, 3, 6, 4, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (2, 0, 3, 4, 6, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (2, 3, 0, 6, 7, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (2, 3, 0, 6, 4, 7))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.vvvv, (6, 7, 1, 5), (2, 3, 0, 4, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t3, (5, 2, 3, 6, 7, 8), (0, 4, 5, 6, 7, 8)) * -0.5
    t3new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t3, (5, 2, 3, 6, 7, 8), (0, 5, 4, 6, 7, 8)) * 0.5
    t3new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t3, (5, 2, 3, 6, 7, 8), (4, 0, 5, 6, 7, 8)) * 0.5
    t3new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t3, (5, 2, 3, 6, 7, 8), (5, 0, 4, 6, 7, 8)) * -0.5
    t3new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t3, (5, 2, 3, 6, 7, 8), (4, 5, 0, 6, 7, 8)) * -0.5
    t3new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t3, (5, 2, 3, 6, 7, 8), (5, 4, 0, 6, 7, 8)) * 0.5
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (3, 5, 6, 1, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (5, 3, 6, 1, 7, 8))
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (5, 6, 3, 1, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (3, 5, 6, 7, 1, 8))
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (5, 3, 6, 7, 1, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (5, 6, 3, 7, 1, 8))
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (3, 5, 6, 7, 8, 1)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (5, 3, 6, 7, 8, 1))
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t3, (5, 6, 2, 7, 8, 4), (5, 6, 3, 7, 8, 1)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t3, (4, 5, 2, 6, 7, 8), (3, 4, 5, 6, 7, 8))
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t3, (4, 5, 2, 6, 7, 8), (4, 3, 5, 6, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t3, (4, 5, 2, 6, 7, 8), (4, 5, 3, 6, 7, 8))
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (0, 5, 6, 3, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (0, 5, 6, 7, 3, 8))
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (0, 5, 6, 7, 8, 3)) * -1.0
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (5, 0, 6, 3, 7, 8))
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (5, 0, 6, 7, 3, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (5, 0, 6, 7, 8, 3))
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (5, 6, 0, 3, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (5, 6, 0, 7, 3, 8))
    t3new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t3, (5, 6, 2, 7, 8, 4), (5, 6, 0, 7, 8, 3)) * -1.0
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t3, (5, 6, 7, 8, 3, 4), (5, 6, 7, 1, 2, 8)) * -0.5
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t3, (5, 6, 7, 8, 3, 4), (5, 6, 7, 1, 8, 2)) * 0.5
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t3, (5, 6, 7, 8, 3, 4), (5, 6, 7, 2, 1, 8)) * 0.5
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t3, (5, 6, 7, 8, 3, 4), (5, 6, 7, 8, 1, 2)) * -0.5
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t3, (5, 6, 7, 8, 3, 4), (5, 6, 7, 2, 8, 1)) * -0.5
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t3, (5, 6, 7, 8, 3, 4), (5, 6, 7, 8, 2, 1)) * 0.5
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t3, (4, 5, 6, 7, 8, 3), (4, 5, 6, 2, 7, 8))
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t3, (4, 5, 6, 7, 8, 3), (4, 5, 6, 7, 2, 8)) * -1.0
    t3new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t3, (4, 5, 6, 7, 8, 3), (4, 5, 6, 7, 8, 2))
    t3new += einsum(t1, (0, 1), v.oovv, (2, 3, 1, 4), t4, (5, 6, 2, 3, 7, 8, 9, 4), (0, 5, 6, 7, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), v.oovv, (2, 3, 1, 4), t4, (5, 6, 2, 3, 7, 8, 9, 4), (5, 0, 6, 7, 8, 9)) * 0.5
    t3new += einsum(t1, (0, 1), v.oovv, (2, 3, 1, 4), t4, (5, 6, 2, 3, 7, 8, 9, 4), (5, 6, 0, 7, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), v.oovv, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 3, 4), (5, 6, 7, 1, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), v.oovv, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 3, 4), (5, 6, 7, 8, 1, 9)) * 0.5
    t3new += einsum(t1, (0, 1), v.oovv, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 3, 4), (5, 6, 7, 8, 9, 1)) * -0.5
    t3new += einsum(t1, (0, 1), v.oovv, (0, 2, 1, 3), t4, (4, 5, 6, 2, 7, 8, 9, 3), (4, 5, 6, 7, 8, 9))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (0, 4, 8, 2, 6, 3)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (0, 4, 8, 2, 6, 7))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (0, 4, 8, 2, 3, 6))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (0, 4, 8, 6, 2, 3))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (0, 4, 8, 6, 2, 7)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (0, 4, 8, 6, 7, 2))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (0, 8, 4, 2, 6, 3))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (0, 8, 4, 2, 6, 7)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (0, 8, 4, 2, 3, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (0, 8, 4, 6, 2, 3)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (0, 8, 4, 6, 2, 7))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (0, 8, 4, 6, 7, 2)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (0, 1, 8, 2, 6, 7)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (0, 1, 8, 6, 2, 7)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (0, 1, 8, 6, 7, 2)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (0, 8, 1, 2, 6, 7)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (0, 8, 1, 6, 2, 7)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (0, 8, 1, 6, 7, 2)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (8, 0, 4, 2, 6, 3)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (8, 0, 4, 2, 6, 7))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (8, 0, 4, 2, 3, 6))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 7), (8, 0, 4, 6, 2, 3))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (8, 0, 4, 6, 2, 7)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (1, 5, 8, 3), (8, 0, 4, 6, 7, 2))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (8, 0, 1, 2, 6, 7)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (8, 0, 1, 6, 2, 7)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ooov, (4, 5, 8, 3), (8, 0, 1, 6, 7, 2)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 4, 1, 8, 2, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 4, 1, 8, 6, 2))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 2, 3), (0, 4, 1, 8, 6, 7)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 4, 1, 2, 8, 6))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 4, 1, 6, 8, 2)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 2, 3), (0, 4, 1, 6, 8, 7)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 4, 1, 2, 6, 8)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 4, 1, 6, 2, 8))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 2, 3), (0, 4, 1, 6, 7, 8)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 3, 7), (0, 4, 5, 8, 2, 6))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 6, 7), (0, 4, 5, 8, 2, 3)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 3, 7), (0, 4, 5, 8, 6, 2)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 3, 7), (0, 4, 5, 2, 8, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 6, 7), (0, 4, 5, 2, 8, 3)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 3, 7), (0, 4, 5, 6, 8, 2))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 3, 7), (0, 4, 5, 2, 6, 8))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 6, 7), (0, 4, 5, 2, 3, 8)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (1, 8, 3, 7), (0, 4, 5, 6, 2, 8)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 1, 4, 8, 2, 6))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 1, 4, 8, 6, 2)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 2, 3), (0, 1, 4, 8, 6, 7)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 1, 4, 2, 8, 6)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 1, 4, 6, 8, 2))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 2, 3), (0, 1, 4, 6, 8, 7)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 1, 4, 2, 6, 8))
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 3, 7), (0, 1, 4, 6, 2, 8)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 2, 3), (0, 1, 4, 6, 7, 8)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (0, 1, 7, 2, 8, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (0, 1, 7, 8, 2, 9)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (0, 1, 7, 8, 9, 2)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t3, (6, 4, 5, 7, 8, 9), (0, 1, 6, 7, 8, 9)) * 0.25
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (0, 7, 1, 2, 8, 9)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (0, 7, 1, 8, 2, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (0, 7, 1, 8, 9, 2)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t3, (6, 4, 5, 7, 8, 9), (0, 6, 1, 7, 8, 9)) * -0.25
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (0, 7, 8, 2, 3, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (0, 7, 8, 2, 9, 3)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (0, 6, 7, 2, 8, 9))
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (0, 7, 8, 9, 2, 3)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (0, 6, 7, 8, 2, 9)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (0, 6, 7, 8, 9, 2))
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t3, (5, 6, 4, 7, 8, 9), (0, 5, 6, 7, 8, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (7, 0, 1, 2, 8, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (7, 0, 1, 8, 2, 9)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t3, (7, 4, 5, 8, 9, 6), (7, 0, 1, 8, 9, 2)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t3, (6, 4, 5, 7, 8, 9), (6, 0, 1, 7, 8, 9)) * 0.25
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (7, 0, 8, 2, 3, 9)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (7, 0, 8, 2, 9, 3)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (6, 0, 7, 2, 8, 9)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (7, 0, 8, 9, 2, 3)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (6, 0, 7, 8, 2, 9))
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (6, 0, 7, 8, 9, 2)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t3, (5, 6, 4, 7, 8, 9), (5, 0, 6, 7, 8, 9)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (7, 8, 0, 2, 3, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (7, 8, 0, 2, 9, 3)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (6, 7, 0, 2, 8, 9))
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t3, (7, 8, 4, 9, 5, 6), (7, 8, 0, 9, 2, 3)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (6, 7, 0, 8, 2, 9)) * -1.0
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t3, (6, 7, 4, 8, 9, 5), (6, 7, 0, 8, 9, 2))
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t3, (5, 6, 4, 7, 8, 9), (5, 6, 0, 7, 8, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t3, (6, 7, 8, 9, 4, 5), (6, 7, 8, 2, 3, 9)) * 0.25
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t3, (6, 7, 8, 9, 4, 5), (6, 7, 8, 2, 9, 3)) * -0.25
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 2, 8, 9)) * 0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t3, (6, 7, 8, 9, 4, 5), (6, 7, 8, 9, 2, 3)) * 0.25
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 8, 2, 9)) * -0.5
    t3new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 8, 9, 2)) * 0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (0, 4, 8, 3, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (0, 8, 4, 3, 6, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (0, 4, 8, 6, 3, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (0, 8, 4, 6, 3, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (0, 4, 8, 6, 7, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (0, 8, 4, 6, 7, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (4, 0, 8, 3, 6, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (8, 0, 4, 3, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (4, 0, 8, 6, 3, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (8, 0, 4, 6, 3, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (4, 0, 8, 6, 7, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (8, 0, 4, 6, 7, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (4, 8, 0, 3, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (8, 4, 0, 3, 6, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (4, 8, 0, 6, 3, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (8, 4, 0, 6, 3, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (4, 8, 0, 6, 7, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (2, 5, 8, 1), (8, 4, 0, 6, 7, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (4, 5, 8, 1, 3, 6)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (4, 8, 5, 1, 3, 6))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (8, 4, 5, 1, 3, 6)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (4, 5, 8, 1, 6, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (4, 8, 5, 1, 6, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (8, 4, 5, 1, 6, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (4, 5, 8, 6, 1, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (4, 8, 5, 6, 1, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ooov, (0, 2, 8, 7), (8, 4, 5, 6, 1, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (0, 2, 4, 8, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (0, 2, 4, 6, 8, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (0, 2, 4, 6, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (0, 4, 2, 8, 6, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (0, 4, 2, 6, 8, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (0, 4, 2, 6, 7, 8))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (0, 4, 5, 3, 8, 6))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (0, 4, 5, 3, 6, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (0, 4, 5, 8, 3, 6)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (0, 4, 5, 6, 3, 8))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (0, 4, 5, 8, 6, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (0, 4, 5, 6, 8, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (4, 0, 2, 8, 6, 7)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (4, 0, 2, 6, 8, 7))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (5, 8, 1, 3), (4, 0, 2, 6, 7, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 0, 5, 3, 8, 6)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 0, 5, 3, 6, 8))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 0, 5, 8, 3, 6))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 0, 5, 6, 3, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 0, 5, 8, 6, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 0, 5, 6, 8, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 5, 0, 3, 8, 6))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 5, 0, 3, 6, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 5, 0, 8, 3, 6)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 5, 0, 6, 3, 8))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 5, 0, 8, 6, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), v.ovvv, (2, 8, 1, 7), (4, 5, 0, 6, 8, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t3, (6, 4, 5, 7, 8, 9), (0, 2, 6, 7, 8, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t3, (6, 4, 5, 7, 8, 9), (0, 6, 2, 7, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (0, 6, 7, 3, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (0, 6, 7, 8, 3, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (0, 6, 7, 8, 9, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t3, (5, 6, 4, 7, 8, 9), (0, 5, 6, 7, 8, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t3, (6, 4, 5, 7, 8, 9), (6, 0, 2, 7, 8, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (6, 0, 7, 3, 8, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (6, 0, 7, 8, 3, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (6, 0, 7, 8, 9, 3))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t3, (5, 6, 4, 7, 8, 9), (5, 0, 6, 7, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (6, 7, 0, 3, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (6, 7, 0, 8, 3, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t3, (6, 7, 4, 8, 9, 5), (6, 7, 0, 8, 9, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t3, (5, 6, 4, 7, 8, 9), (5, 6, 0, 7, 8, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t3, (6, 7, 8, 9, 4, 5), (6, 7, 8, 1, 3, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t3, (6, 7, 8, 9, 4, 5), (6, 7, 8, 1, 9, 3)) * -0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t3, (6, 7, 8, 9, 4, 5), (6, 7, 8, 9, 1, 3)) * 0.5
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 3, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 8, 3, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 8, 9, 3)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (0, 2, 6, 4, 8, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (0, 2, 6, 4, 8, 9))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (0, 2, 6, 4, 5, 8))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (0, 2, 6, 8, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (0, 2, 6, 8, 4, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (0, 2, 6, 8, 9, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (0, 2, 3, 4, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (0, 2, 3, 8, 4, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (0, 2, 3, 8, 9, 4)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (2, 0, 6, 4, 8, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (2, 0, 6, 4, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (2, 0, 6, 4, 5, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (2, 0, 6, 8, 4, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (2, 0, 6, 8, 4, 9))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (2, 0, 6, 8, 9, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (2, 0, 3, 4, 8, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (2, 0, 3, 8, 4, 9)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (2, 0, 3, 8, 9, 4)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (2, 6, 0, 4, 8, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (2, 6, 0, 4, 8, 9))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (2, 6, 0, 4, 5, 8))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 9), (2, 6, 0, 8, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (2, 6, 0, 8, 4, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (3, 7, 1, 5), (2, 6, 0, 8, 9, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (2, 3, 0, 4, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (2, 3, 0, 8, 4, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (6, 7, 1, 5), (2, 3, 0, 8, 9, 4)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 6, 3, 1, 4, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 6, 3, 1, 8, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 4, 5), (2, 6, 3, 1, 8, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 5, 9), (2, 6, 7, 1, 4, 8))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 8, 9), (2, 6, 7, 1, 4, 5)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 5, 9), (2, 6, 7, 1, 8, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 3, 6, 1, 4, 8))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 3, 6, 1, 8, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 4, 5), (2, 3, 6, 1, 8, 9)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 6, 3, 4, 1, 8))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 6, 3, 8, 1, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 4, 5), (2, 6, 3, 8, 1, 9)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 5, 9), (2, 6, 7, 4, 1, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 8, 9), (2, 6, 7, 4, 1, 5)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 5, 9), (2, 6, 7, 8, 1, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 3, 6, 4, 1, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 3, 6, 8, 1, 4))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 4, 5), (2, 3, 6, 8, 1, 9)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 6, 3, 4, 8, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 6, 3, 8, 4, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 4, 5), (2, 6, 3, 8, 9, 1)) * 0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 5, 9), (2, 6, 7, 4, 8, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 8, 9), (2, 6, 7, 4, 5, 1)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 5, 9), (2, 6, 7, 8, 4, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 3, 6, 4, 8, 1))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 5, 9), (2, 3, 6, 8, 4, 1)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 4, 5), (2, 3, 6, 8, 9, 1)) * -0.5
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 1, 5), (2, 6, 3, 4, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 1, 5), (2, 6, 3, 8, 4, 9))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 1, 5), (2, 6, 3, 8, 9, 4)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 1, 9), (2, 6, 7, 4, 8, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 1, 9), (2, 6, 7, 4, 5, 8))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 3, 1, 9), (2, 6, 7, 8, 4, 5))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 1, 5), (2, 3, 6, 4, 8, 9))
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 1, 5), (2, 3, 6, 8, 4, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.oovv, (0, 7, 1, 5), (2, 3, 6, 8, 9, 4))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (0, 2, 6, 5, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (0, 2, 6, 8, 5, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (0, 2, 6, 8, 9, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (0, 6, 2, 5, 8, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (0, 6, 2, 8, 5, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (0, 6, 2, 8, 9, 5))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (0, 6, 7, 3, 5, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (0, 6, 7, 3, 8, 5))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (0, 6, 7, 8, 3, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (6, 0, 2, 5, 8, 9)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (6, 0, 2, 8, 5, 9))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (4, 7, 1, 3), (6, 0, 2, 8, 9, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (6, 0, 7, 3, 5, 8))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (6, 0, 7, 3, 8, 5)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (6, 0, 7, 8, 3, 5))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (6, 7, 0, 3, 5, 8)) * -1.0
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (6, 7, 0, 3, 8, 5))
    t3new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), t2, (6, 7, 8, 9), v.oovv, (2, 4, 1, 9), (6, 7, 0, 8, 3, 5)) * -1.0
    t4new = np.zeros((nocc, nocc, nocc, nocc, nvir, nvir, nvir, nvir), dtype=np.float64)
    t4new += einsum(f.oo, (0, 1), t4, (2, 3, 4, 1, 5, 6, 7, 8), (0, 2, 3, 4, 5, 6, 7, 8))
    t4new += einsum(f.oo, (0, 1), t4, (2, 3, 4, 1, 5, 6, 7, 8), (2, 0, 3, 4, 5, 6, 7, 8)) * -1.0
    t4new += einsum(f.oo, (0, 1), t4, (2, 3, 4, 1, 5, 6, 7, 8), (2, 3, 0, 4, 5, 6, 7, 8))
    t4new += einsum(f.oo, (0, 1), t4, (2, 3, 4, 1, 5, 6, 7, 8), (2, 3, 4, 0, 5, 6, 7, 8)) * -1.0
    t4new += einsum(f.vv, (0, 1), t4, (2, 3, 4, 5, 6, 7, 8, 1), (2, 3, 4, 5, 0, 6, 7, 8)) * -1.0
    t4new += einsum(f.vv, (0, 1), t4, (2, 3, 4, 5, 6, 7, 8, 1), (2, 3, 4, 5, 6, 0, 7, 8))
    t4new += einsum(f.vv, (0, 1), t4, (2, 3, 4, 5, 6, 7, 8, 1), (2, 3, 4, 5, 6, 7, 0, 8)) * -1.0
    t4new += einsum(f.vv, (0, 1), t4, (2, 3, 4, 5, 6, 7, 8, 1), (2, 3, 4, 5, 6, 7, 8, 0))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 1, 4, 5, 3, 6, 7, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 1, 4, 5, 6, 3, 7, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 1, 4, 5, 6, 7, 3, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 1, 4, 5, 6, 7, 8, 3)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 1, 5, 3, 6, 7, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 1, 5, 6, 3, 7, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 1, 5, 6, 7, 3, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 1, 5, 6, 7, 8, 3))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 5, 1, 3, 6, 7, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 5, 1, 6, 3, 7, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 5, 1, 6, 7, 3, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (0, 4, 5, 1, 6, 7, 8, 3)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 1, 5, 3, 6, 7, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 1, 5, 6, 3, 7, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 1, 5, 6, 7, 3, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 1, 5, 6, 7, 8, 3)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 5, 1, 3, 6, 7, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 5, 1, 6, 3, 7, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 5, 1, 6, 7, 3, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 0, 5, 1, 6, 7, 8, 3))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 5, 0, 1, 3, 6, 7, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 5, 0, 1, 6, 3, 7, 8)) * -1.0
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 5, 0, 1, 6, 7, 3, 8))
    t4new += einsum(v.ooov, (0, 1, 2, 3), t3, (4, 5, 2, 6, 7, 8), (4, 5, 0, 1, 6, 7, 8, 3)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (0, 4, 5, 6, 2, 3, 7, 8))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (0, 4, 5, 6, 2, 7, 3, 8)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (0, 4, 5, 6, 2, 7, 8, 3))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (0, 4, 5, 6, 7, 2, 3, 8))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (0, 4, 5, 6, 7, 2, 8, 3)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (0, 4, 5, 6, 7, 8, 2, 3))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 0, 5, 6, 2, 3, 7, 8)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 0, 5, 6, 2, 7, 3, 8))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 0, 5, 6, 2, 7, 8, 3)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 0, 5, 6, 7, 2, 3, 8)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 0, 5, 6, 7, 2, 8, 3))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 0, 5, 6, 7, 8, 2, 3)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 0, 6, 2, 3, 7, 8))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 0, 6, 2, 7, 3, 8)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 0, 6, 2, 7, 8, 3))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 0, 6, 7, 2, 3, 8))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 0, 6, 7, 2, 8, 3)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 0, 6, 7, 8, 2, 3))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 6, 0, 2, 3, 7, 8)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 6, 0, 2, 7, 3, 8))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 6, 0, 2, 7, 8, 3)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 6, 0, 7, 2, 3, 8)) * -1.0
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 6, 0, 7, 2, 8, 3))
    t4new += einsum(v.ovvv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 1), (4, 5, 6, 0, 7, 8, 2, 3)) * -1.0
    t4new += einsum(v.oooo, (0, 1, 2, 3), t4, (4, 5, 2, 3, 6, 7, 8, 9), (0, 1, 4, 5, 6, 7, 8, 9)) * 0.5
    t4new += einsum(v.oooo, (0, 1, 2, 3), t4, (4, 5, 2, 3, 6, 7, 8, 9), (0, 4, 1, 5, 6, 7, 8, 9)) * -0.5
    t4new += einsum(v.oooo, (0, 1, 2, 3), t4, (4, 5, 2, 3, 6, 7, 8, 9), (0, 4, 5, 1, 6, 7, 8, 9)) * 0.5
    t4new += einsum(v.oooo, (0, 1, 2, 3), t4, (4, 5, 2, 3, 6, 7, 8, 9), (4, 0, 1, 5, 6, 7, 8, 9)) * 0.5
    t4new += einsum(v.oooo, (0, 1, 2, 3), t4, (4, 5, 2, 3, 6, 7, 8, 9), (4, 0, 5, 1, 6, 7, 8, 9)) * -0.5
    t4new += einsum(v.oooo, (0, 1, 2, 3), t4, (4, 5, 2, 3, 6, 7, 8, 9), (4, 5, 0, 1, 6, 7, 8, 9)) * 0.5
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (0, 4, 5, 6, 3, 7, 8, 9)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (0, 4, 5, 6, 7, 3, 8, 9))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (0, 4, 5, 6, 7, 8, 3, 9)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (0, 4, 5, 6, 7, 8, 9, 3))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 0, 5, 6, 3, 7, 8, 9))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 0, 5, 6, 7, 3, 8, 9)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 0, 5, 6, 7, 8, 3, 9))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 0, 5, 6, 7, 8, 9, 3)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 0, 6, 3, 7, 8, 9)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 0, 6, 7, 3, 8, 9))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 0, 6, 7, 8, 3, 9)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 0, 6, 7, 8, 9, 3))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 6, 0, 3, 7, 8, 9))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 6, 0, 7, 3, 8, 9)) * -1.0
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 6, 0, 7, 8, 3, 9))
    t4new += einsum(v.ovov, (0, 1, 2, 3), t4, (4, 5, 6, 2, 7, 8, 9, 1), (4, 5, 6, 0, 7, 8, 9, 3)) * -1.0
    t4new += einsum(v.vvvv, (0, 1, 2, 3), t4, (4, 5, 6, 7, 8, 9, 2, 3), (4, 5, 6, 7, 0, 1, 8, 9)) * 0.5
    t4new += einsum(v.vvvv, (0, 1, 2, 3), t4, (4, 5, 6, 7, 8, 9, 2, 3), (4, 5, 6, 7, 0, 8, 1, 9)) * -0.5
    t4new += einsum(v.vvvv, (0, 1, 2, 3), t4, (4, 5, 6, 7, 8, 9, 2, 3), (4, 5, 6, 7, 0, 8, 9, 1)) * 0.5
    t4new += einsum(v.vvvv, (0, 1, 2, 3), t4, (4, 5, 6, 7, 8, 9, 2, 3), (4, 5, 6, 7, 8, 0, 1, 9)) * 0.5
    t4new += einsum(v.vvvv, (0, 1, 2, 3), t4, (4, 5, 6, 7, 8, 9, 2, 3), (4, 5, 6, 7, 8, 0, 9, 1)) * -0.5
    t4new += einsum(v.vvvv, (0, 1, 2, 3), t4, (4, 5, 6, 7, 8, 9, 2, 3), (4, 5, 6, 7, 8, 9, 0, 1)) * 0.5
    t4new += einsum(f.ov, (0, 1), t1, (2, 1), t4, (3, 4, 5, 0, 6, 7, 8, 9), (2, 3, 4, 5, 6, 7, 8, 9))
    t4new += einsum(f.ov, (0, 1), t1, (2, 1), t4, (3, 4, 5, 0, 6, 7, 8, 9), (3, 2, 4, 5, 6, 7, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t1, (2, 1), t4, (3, 4, 5, 0, 6, 7, 8, 9), (3, 4, 2, 5, 6, 7, 8, 9))
    t4new += einsum(f.ov, (0, 1), t1, (2, 1), t4, (3, 4, 5, 0, 6, 7, 8, 9), (3, 4, 5, 2, 6, 7, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t1, (0, 2), t4, (3, 4, 5, 6, 7, 8, 9, 1), (3, 4, 5, 6, 2, 7, 8, 9))
    t4new += einsum(f.ov, (0, 1), t1, (0, 2), t4, (3, 4, 5, 6, 7, 8, 9, 1), (3, 4, 5, 6, 7, 2, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t1, (0, 2), t4, (3, 4, 5, 6, 7, 8, 9, 1), (3, 4, 5, 6, 7, 8, 2, 9))
    t4new += einsum(f.ov, (0, 1), t1, (0, 2), t4, (3, 4, 5, 6, 7, 8, 9, 1), (3, 4, 5, 6, 7, 8, 9, 2)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 3, 5, 6, 4, 7, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 3, 5, 6, 7, 4, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 3, 5, 6, 7, 8, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 3, 5, 6, 7, 8, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 3, 6, 4, 7, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 3, 6, 7, 4, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 3, 6, 7, 8, 4, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 3, 6, 7, 8, 9, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 6, 3, 4, 7, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 6, 3, 7, 4, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 6, 3, 7, 8, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (2, 5, 6, 3, 7, 8, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (2, 5, 6, 7, 3, 4, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (2, 5, 6, 7, 3, 8, 4, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (2, 5, 6, 7, 3, 8, 9, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (2, 5, 6, 7, 8, 3, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (2, 5, 6, 7, 8, 3, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (2, 5, 6, 7, 8, 9, 3, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 3, 6, 4, 7, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 3, 6, 7, 4, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 3, 6, 7, 8, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 3, 6, 7, 8, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 6, 3, 4, 7, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 6, 3, 7, 4, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 6, 3, 7, 8, 4, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 2, 6, 3, 7, 8, 9, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 2, 6, 7, 3, 4, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 2, 6, 7, 3, 8, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 2, 6, 7, 3, 8, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 2, 6, 7, 8, 3, 4, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 2, 6, 7, 8, 3, 9, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 2, 6, 7, 8, 9, 3, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 6, 2, 3, 4, 7, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 6, 2, 3, 7, 4, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 6, 2, 3, 7, 8, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), t3, (5, 6, 0, 7, 8, 9), (5, 6, 2, 3, 7, 8, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 2, 7, 3, 4, 8, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 2, 7, 3, 8, 4, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 2, 7, 3, 8, 9, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 2, 7, 8, 3, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 2, 7, 8, 3, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 2, 7, 8, 9, 3, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 7, 2, 3, 4, 8, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 7, 2, 3, 8, 4, 9)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 7, 2, 3, 8, 9, 4))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 7, 2, 8, 3, 4, 9))
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 7, 2, 8, 3, 9, 4)) * -1.0
    t4new += einsum(f.ov, (0, 1), t2, (2, 0, 3, 4), t3, (5, 6, 7, 8, 9, 1), (5, 6, 7, 2, 8, 9, 3, 4))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 3, 5, 6, 1, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 3, 6, 1, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 6, 3, 1, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 3, 6, 1, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 6, 3, 1, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 6, 2, 3, 1, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 3, 5, 6, 7, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 3, 6, 7, 1, 8, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 6, 3, 7, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 3, 6, 7, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 6, 3, 7, 1, 8, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 6, 2, 3, 7, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 3, 5, 6, 7, 8, 1, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 3, 6, 7, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 6, 3, 7, 8, 1, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 3, 6, 7, 8, 1, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 6, 3, 7, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 6, 2, 3, 7, 8, 1, 9))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 3, 5, 6, 7, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 3, 6, 7, 8, 9, 1))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (2, 5, 6, 3, 7, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 3, 6, 7, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 2, 6, 3, 7, 8, 9, 1))
    t4new += einsum(t1, (0, 1), v.oooo, (2, 3, 0, 4), t3, (5, 6, 4, 7, 8, 9), (5, 6, 2, 3, 7, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 2, 5, 6, 4, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 2, 5, 6, 7, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 2, 5, 6, 7, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 2, 5, 6, 7, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 2, 6, 4, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 2, 6, 7, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 2, 6, 7, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 2, 6, 7, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 6, 2, 4, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 6, 2, 7, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 6, 2, 7, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (0, 5, 6, 2, 7, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 0, 5, 6, 4, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 0, 5, 6, 7, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 0, 5, 6, 7, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 0, 5, 6, 7, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 2, 6, 4, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 2, 6, 7, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 2, 6, 7, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 2, 6, 7, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 6, 2, 4, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 6, 2, 7, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 6, 2, 7, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 0, 6, 2, 7, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 0, 6, 4, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 0, 6, 7, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 0, 6, 7, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 0, 6, 7, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 0, 6, 4, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 0, 6, 7, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 0, 6, 7, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 0, 6, 7, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 0, 2, 4, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 0, 2, 7, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 0, 2, 7, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 0, 2, 7, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 6, 0, 4, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 6, 0, 7, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 6, 0, 7, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (2, 5, 6, 0, 7, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 6, 0, 4, 7, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 6, 0, 7, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 6, 0, 7, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 2, 6, 0, 7, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 2, 0, 4, 7, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 2, 0, 7, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 2, 0, 7, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 1, 3, 4), t3, (5, 6, 3, 7, 8, 9), (5, 6, 2, 0, 7, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 1, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 1, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 1, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 1, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 1, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 1, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 1, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 1, 8, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 1, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 1, 4, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 1, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 1, 8, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 4, 1, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 8, 1, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 8, 1, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 4, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 8, 1, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 8, 1, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 4, 1, 8, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 8, 1, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 8, 1, 9, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 4, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 8, 1, 4, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 8, 1, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 4, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 8, 4, 1, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 8, 9, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 4, 8, 1, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 8, 4, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 8, 9, 1, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 4, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 8, 4, 1, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 8, 9, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 4, 8, 1, 9))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 8, 4, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 8, 9, 1, 4))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 4, 8, 9, 1))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 8, 4, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (2, 5, 6, 7, 8, 9, 4, 1))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 4, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 8, 4, 9, 1))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 2, 6, 7, 8, 9, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 4, 8, 9, 1))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 8, 4, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 2, 7, 8, 9, 4, 1))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 4, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 8, 4, 9, 1))
    t4new += einsum(t1, (0, 1), v.ovov, (2, 3, 0, 4), t3, (5, 6, 7, 8, 9, 3), (5, 6, 7, 2, 8, 9, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (0, 5, 6, 7, 2, 3, 8, 9))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (0, 5, 6, 7, 2, 8, 3, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (0, 5, 6, 7, 2, 8, 9, 3))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (0, 5, 6, 7, 8, 2, 3, 9))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (0, 5, 6, 7, 8, 2, 9, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (0, 5, 6, 7, 8, 9, 2, 3))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 0, 6, 7, 2, 3, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 0, 6, 7, 2, 8, 3, 9))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 0, 6, 7, 2, 8, 9, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 0, 6, 7, 8, 2, 3, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 0, 6, 7, 8, 2, 9, 3))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 0, 6, 7, 8, 9, 2, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 0, 7, 2, 3, 8, 9))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 0, 7, 2, 8, 3, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 0, 7, 2, 8, 9, 3))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 0, 7, 8, 2, 3, 9))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 0, 7, 8, 2, 9, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 0, 7, 8, 9, 2, 3))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 0, 2, 3, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 0, 2, 8, 3, 9))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 0, 2, 8, 9, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 0, 8, 2, 3, 9)) * -1.0
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 0, 8, 2, 9, 3))
    t4new += einsum(t1, (0, 1), v.vvvv, (2, 3, 1, 4), t3, (5, 6, 7, 8, 9, 4), (5, 6, 7, 0, 8, 9, 2, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (0, 4, 5, 6, 7, 8, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (0, 5, 4, 6, 7, 8, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (0, 5, 6, 4, 7, 8, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (4, 0, 5, 6, 7, 8, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (5, 0, 4, 6, 7, 8, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (5, 0, 6, 4, 7, 8, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (4, 5, 0, 6, 7, 8, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (5, 4, 0, 6, 7, 8, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (5, 6, 0, 4, 7, 8, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (4, 5, 6, 0, 7, 8, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (5, 4, 6, 0, 7, 8, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ooov, (2, 3, 4, 1), t4, (5, 6, 2, 3, 7, 8, 9, 10), (5, 6, 4, 0, 7, 8, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (3, 5, 6, 7, 1, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 3, 6, 7, 1, 8, 9, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 3, 7, 1, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 3, 1, 8, 9, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (3, 5, 6, 7, 8, 1, 9, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 3, 6, 7, 8, 1, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 3, 7, 8, 1, 9, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 3, 8, 1, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (3, 5, 6, 7, 8, 9, 1, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 3, 6, 7, 8, 9, 1, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 3, 7, 8, 9, 1, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 3, 8, 9, 1, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (3, 5, 6, 7, 8, 9, 10, 1))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 3, 6, 7, 8, 9, 10, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 3, 7, 8, 9, 10, 1))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 3, 8, 9, 10, 1)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t4, (4, 5, 6, 2, 7, 8, 9, 10), (3, 4, 5, 6, 7, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t4, (4, 5, 6, 2, 7, 8, 9, 10), (4, 3, 5, 6, 7, 8, 9, 10))
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t4, (4, 5, 6, 2, 7, 8, 9, 10), (4, 5, 3, 6, 7, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ooov, (0, 2, 3, 1), t4, (4, 5, 6, 2, 7, 8, 9, 10), (4, 5, 6, 3, 7, 8, 9, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (0, 5, 6, 7, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (0, 5, 6, 7, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (0, 5, 6, 7, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (0, 5, 6, 7, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 0, 6, 7, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 0, 6, 7, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 0, 6, 7, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 0, 6, 7, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 0, 7, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 0, 7, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 0, 7, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 0, 7, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 0, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 0, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 0, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (2, 3, 1, 4), t4, (5, 6, 7, 2, 8, 9, 10, 4), (5, 6, 7, 0, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 1, 2, 9, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 1, 9, 2, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 1, 9, 10, 2)) * -0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 2, 1, 9, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 9, 1, 2, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 9, 1, 10, 2)) * 0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 2, 9, 1, 10)) * -0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 9, 2, 1, 10)) * 0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 9, 10, 1, 2)) * -0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 2, 9, 10, 1)) * 0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 9, 2, 10, 1)) * -0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 3, 4), t4, (5, 6, 7, 8, 9, 10, 3, 4), (5, 6, 7, 8, 9, 10, 2, 1)) * 0.5
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t4, (4, 5, 6, 7, 8, 9, 10, 3), (4, 5, 6, 7, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t4, (4, 5, 6, 7, 8, 9, 10, 3), (4, 5, 6, 7, 8, 2, 9, 10))
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t4, (4, 5, 6, 7, 8, 9, 10, 3), (4, 5, 6, 7, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t1, (0, 1), v.ovvv, (0, 2, 1, 3), t4, (4, 5, 6, 7, 8, 9, 10, 3), (4, 5, 6, 7, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 4, 8, 9, 2, 6, 3, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 4, 8, 9, 2, 6, 7, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 4, 8, 9, 2, 3, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 4, 8, 9, 6, 2, 3, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 4, 8, 9, 6, 2, 7, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 4, 8, 9, 6, 7, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 4, 9, 2, 6, 3, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 4, 9, 2, 6, 7, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 4, 9, 2, 3, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 4, 9, 6, 2, 3, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 4, 9, 6, 2, 7, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 4, 9, 6, 7, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 9, 4, 2, 6, 3, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 9, 4, 2, 6, 7, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 9, 4, 2, 3, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 9, 4, 6, 2, 3, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 9, 4, 6, 2, 7, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (0, 8, 9, 4, 6, 7, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 4, 9, 2, 6, 3, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 4, 9, 2, 6, 7, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 4, 9, 2, 3, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 4, 9, 6, 2, 3, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 4, 9, 6, 2, 7, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 4, 9, 6, 7, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 9, 4, 2, 6, 3, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 9, 4, 2, 6, 7, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 9, 4, 2, 3, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 9, 4, 6, 2, 3, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 9, 4, 6, 2, 7, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 0, 9, 4, 6, 7, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 9, 0, 4, 2, 6, 3, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 9, 0, 4, 2, 6, 7, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 9, 0, 4, 2, 3, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 9, 0, 4, 6, 2, 3, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 9, 0, 4, 6, 2, 7, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.oooo, (8, 9, 1, 5), (8, 9, 0, 4, 6, 7, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 2, 6, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 2, 6, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 2, 9, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 6, 2, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 6, 2, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 9, 2, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 6, 7, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 6, 9, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 9, 6, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 6, 7, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 6, 9, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 8, 1, 9, 6, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 2, 6, 3, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 2, 6, 9, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 2, 3, 6, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 2, 9, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 2, 3, 9, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 2, 9, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 6, 2, 3, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 6, 2, 9, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 9, 2, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 9, 2, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 6, 9, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 8, 5, 9, 6, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 2, 6, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 2, 6, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 2, 9, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 6, 2, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 6, 2, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 9, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 6, 7, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 6, 9, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 9, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 6, 7, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 6, 9, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 4, 1, 8, 9, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 2, 6, 3, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 2, 6, 9, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 2, 3, 6, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 2, 9, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 2, 3, 9, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 2, 9, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 6, 2, 3, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 6, 2, 9, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 9, 2, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 9, 2, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 6, 9, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 4, 5, 8, 9, 6, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 2, 6, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 2, 6, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 2, 9, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 6, 2, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 6, 2, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 9, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 6, 7, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 6, 9, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 9, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 6, 7, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 6, 9, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 4, 1, 9, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 2, 6, 3, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 2, 6, 9, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 2, 3, 6, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 2, 9, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 2, 3, 9, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 2, 9, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 6, 2, 3, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 6, 2, 9, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 9, 2, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 9, 2, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 6, 9, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (0, 8, 4, 5, 9, 6, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 2, 6, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 2, 6, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 2, 9, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 6, 2, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 6, 2, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 9, 2, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 6, 7, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 6, 9, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 9, 6, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 6, 7, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 6, 9, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 4, 8, 9, 6, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 2, 6, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 2, 6, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 2, 9, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 6, 2, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 6, 2, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 9, 2, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 6, 7, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 6, 9, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 9, 6, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 6, 7, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 6, 9, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 8, 1, 4, 9, 6, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 2, 6, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 2, 6, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 2, 9, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 6, 2, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 6, 2, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 9, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 6, 7, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 6, 9, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 9, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 6, 7, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 6, 9, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (0, 1, 8, 4, 9, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 2, 6, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 2, 6, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 2, 9, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 6, 2, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 6, 2, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 9, 2, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 6, 7, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 6, 9, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 9, 6, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 6, 7, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 6, 9, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 4, 1, 9, 6, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 2, 6, 3, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 2, 6, 9, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 2, 3, 6, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 2, 9, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 2, 3, 9, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 2, 9, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 6, 2, 3, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 6, 2, 9, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 9, 2, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 9, 2, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 6, 9, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 7, 1, 9), (8, 0, 4, 5, 9, 6, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 2, 6, 7, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 2, 6, 9, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 2, 9, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 6, 2, 7, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 6, 2, 9, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 9, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 6, 7, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 6, 9, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 9, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 6, 7, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 6, 9, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.ovov, (8, 3, 5, 9), (8, 0, 1, 4, 9, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 8, 9, 2, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 8, 9, 6, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 8, 2, 9, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 8, 6, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 8, 2, 6, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 8, 6, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 8, 9, 2, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 8, 9, 6, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 8, 2, 9, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 8, 6, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 8, 2, 6, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 8, 6, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 2, 8, 9, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 6, 8, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 2, 8, 6, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 6, 8, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 2, 8, 9, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 6, 8, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 2, 8, 6, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 6, 8, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 2, 6, 8, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 1, 5, 6, 2, 8, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 2, 6, 8, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 4, 5, 1, 6, 2, 8, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 8, 9, 2, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 8, 9, 6, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 8, 2, 9, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 8, 6, 9, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 8, 2, 6, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 8, 6, 2, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 2, 8, 9, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 6, 8, 9, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 2, 8, 6, 9))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 6, 8, 2, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 2, 6, 8, 9)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), v.vvvv, (8, 9, 3, 7), (0, 1, 4, 5, 6, 2, 8, 9))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 6, 7, 2, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 7, 6, 2, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 6, 7, 8, 2, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 7, 6, 8, 2, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 6, 7, 8, 9, 2, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 7, 6, 8, 9, 2, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 6, 7, 8, 9, 10, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 1, 7, 6, 8, 9, 10, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 1, 7, 2, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 1, 6, 2, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 1, 7, 8, 2, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 1, 6, 8, 2, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 1, 7, 8, 9, 2, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 1, 6, 8, 9, 2, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 1, 7, 8, 9, 10, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 1, 6, 8, 9, 10, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 7, 1, 2, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 6, 1, 2, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 7, 1, 8, 2, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 6, 1, 8, 2, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 7, 1, 8, 9, 2, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 6, 1, 8, 9, 2, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 6, 7, 1, 8, 9, 10, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (0, 7, 6, 1, 8, 9, 10, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 5, 7, 8, 2, 3, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 5, 7, 8, 2, 9, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 5, 7, 8, 2, 9, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 2, 8, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 5, 8, 2, 3, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 5, 8, 2, 9, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 5, 8, 2, 9, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 5, 2, 3, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 5, 2, 9, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 5, 2, 9, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 2, 8, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 5, 7, 8, 9, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 5, 7, 8, 9, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 8, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 5, 8, 9, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 5, 8, 9, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 8, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 5, 9, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 5, 9, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 8, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 5, 7, 8, 9, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 8, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 5, 8, 9, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 5, 9, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 8, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 8, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 8, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 1, 7, 2, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 1, 6, 2, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 1, 7, 8, 2, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 1, 6, 8, 2, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 1, 7, 8, 9, 2, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 1, 6, 8, 9, 2, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 1, 7, 8, 9, 10, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 1, 6, 8, 9, 10, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 7, 1, 2, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 6, 1, 2, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 7, 1, 8, 2, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 6, 1, 8, 2, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 7, 1, 8, 9, 2, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 6, 1, 8, 9, 2, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 0, 7, 1, 8, 9, 10, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 0, 6, 1, 8, 9, 10, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 0, 7, 8, 2, 3, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 0, 7, 8, 2, 9, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 0, 7, 8, 2, 9, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 5, 8, 2, 3, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 5, 8, 2, 9, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 5, 8, 2, 9, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 2, 8, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 5, 2, 3, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 5, 2, 9, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 5, 2, 9, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 0, 7, 8, 9, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 0, 7, 8, 9, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 8, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 5, 8, 9, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 5, 8, 9, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 8, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 5, 9, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 5, 9, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 8, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 0, 7, 8, 9, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 5, 8, 9, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 8, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 5, 9, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 8, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 7, 0, 1, 2, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 6, 0, 1, 2, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 7, 0, 1, 8, 2, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 6, 0, 1, 8, 2, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 7, 0, 1, 8, 9, 2, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 6, 0, 1, 8, 9, 2, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (6, 7, 0, 1, 8, 9, 10, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (4, 5, 6, 3), t3, (7, 4, 5, 8, 9, 10), (7, 6, 0, 1, 8, 9, 10, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 0, 8, 2, 3, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 0, 8, 2, 9, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 0, 8, 2, 9, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 2, 8, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 0, 8, 2, 3, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 0, 8, 2, 9, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 0, 8, 2, 9, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 5, 2, 3, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 5, 2, 9, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 5, 2, 9, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 2, 8, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 0, 8, 9, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 0, 8, 9, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 8, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 0, 8, 9, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 0, 8, 9, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 8, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 5, 9, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 5, 9, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 8, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 0, 8, 9, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 8, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 0, 8, 9, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 5, 9, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 8, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 8, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 8, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 8, 0, 2, 3, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 8, 0, 2, 9, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 8, 0, 2, 9, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 8, 0, 2, 3, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 8, 0, 2, 9, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 8, 0, 2, 9, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 2, 8, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 5, 0, 2, 3, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 5, 0, 2, 9, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 5, 0, 2, 9, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 2, 8, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 8, 0, 9, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 8, 0, 9, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 8, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 8, 0, 9, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 8, 0, 9, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 8, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 5, 0, 9, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 5, 0, 9, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 8, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (5, 7, 8, 0, 9, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 5, 8, 0, 9, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 8, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 5, 0, 9, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 8, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 8, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (1, 4, 5, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 8, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 2, 3, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 2, 9, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 2, 9, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 2, 3, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 2, 9, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 2, 9, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 2, 3, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 2, 9, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 2, 9, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 2, 3, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 2, 9, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 2, 9, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 9, 2, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 9, 2, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 9, 2, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 9, 2, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 9, 2, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 9, 2, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 9, 2, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 9, 2, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 9, 10, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 9, 10, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 9, 10, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ooov, (0, 1, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 9, 10, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 5, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 5, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 5, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 1, 6, 7, 5, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 2, 5, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 9, 5, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 9, 5, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 1, 6, 7, 8, 5, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 2, 9, 5, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 9, 2, 5, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 9, 10, 5, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 1, 6, 7, 8, 9, 5, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 2, 9, 10, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 9, 2, 10, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 1, 7, 8, 9, 10, 2, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 1, 6, 7, 8, 9, 10, 5)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 5, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 5, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 5, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 1, 7, 5, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 2, 5, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 9, 5, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 9, 5, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 1, 7, 8, 5, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 2, 9, 5, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 9, 2, 5, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 9, 10, 5, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 1, 7, 8, 9, 5, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 2, 9, 10, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 9, 2, 10, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 1, 8, 9, 10, 2, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 1, 7, 8, 9, 10, 5)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 5, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 5, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 5, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 1, 5, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 2, 5, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 9, 5, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 9, 5, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 1, 8, 5, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 2, 9, 5, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 9, 2, 5, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 9, 10, 5, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 1, 8, 9, 5, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 2, 9, 10, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 9, 2, 10, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (0, 7, 8, 1, 9, 10, 2, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 1, 8, 9, 10, 5)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 4, 2, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 4, 2, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 4, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 4, 10, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 4, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 4, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 2, 4, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 2, 4, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 2, 4, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 10, 4, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 4, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 4, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 2, 3, 4, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 2, 10, 4, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 2, 9, 4, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 10, 2, 4, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 2, 4, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 10, 4, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 2, 3, 10, 4)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 2, 10, 3, 4)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 2, 9, 10, 4))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (0, 7, 8, 9, 10, 2, 3, 4)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 2, 10, 4)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 10, 2, 4))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 5, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 5, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 5, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 1, 7, 5, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 2, 5, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 9, 5, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 9, 5, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 1, 7, 8, 5, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 2, 9, 5, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 9, 2, 5, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 9, 10, 5, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 1, 7, 8, 9, 5, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 2, 9, 10, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 9, 2, 10, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 1, 8, 9, 10, 2, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 1, 7, 8, 9, 10, 5)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 5, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 5, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 5, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 1, 5, 8, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 2, 5, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 9, 5, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 9, 5, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 1, 8, 5, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 2, 9, 5, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 9, 2, 5, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 9, 10, 5, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 1, 8, 9, 5, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 2, 9, 10, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 9, 2, 10, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 0, 8, 1, 9, 10, 2, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 1, 8, 9, 10, 5)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 4, 2, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 4, 2, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 4, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 4, 10, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 4, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 4, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 2, 4, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 2, 4, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 2, 4, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 10, 4, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 4, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 4, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 2, 3, 4, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 2, 10, 4, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 2, 9, 4, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 10, 2, 4, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 2, 4, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 10, 4, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 2, 3, 10, 4)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 2, 10, 3, 4)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 2, 9, 10, 4)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 0, 8, 9, 10, 2, 3, 4)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 2, 10, 4))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 10, 2, 4)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 5, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 5, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 5, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 1, 5, 8, 9, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 2, 5, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 9, 5, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 9, 5, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 1, 8, 5, 9, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 2, 9, 5, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 9, 2, 5, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 9, 10, 5, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 1, 8, 9, 5, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 2, 9, 10, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 9, 2, 10, 5))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 3, 6), t3, (7, 8, 4, 9, 10, 6), (7, 8, 0, 1, 9, 10, 2, 5)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (4, 5, 2, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 1, 8, 9, 10, 5)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 4, 2, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 4, 2, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 4, 2, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 4, 10, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 4, 9, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 4, 9, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 2, 4, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 2, 4, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 2, 4, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 10, 4, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 4, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 4, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 2, 3, 4, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 2, 10, 4, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 2, 9, 4, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 10, 2, 4, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 2, 4, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 10, 4, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 2, 3, 10, 4)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 2, 10, 3, 4)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 2, 9, 10, 4))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 0, 9, 10, 2, 3, 4)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 2, 10, 4)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 10, 2, 4))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 4, 2, 3, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 4, 2, 10, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 4, 2, 9, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 4, 10, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 4, 9, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 4, 9, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 2, 4, 3, 10)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 2, 4, 10, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 2, 4, 9, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 10, 4, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 4, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 4, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 2, 3, 4, 10)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 2, 10, 4, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 2, 9, 4, 10))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 10, 2, 4, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 2, 4, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 10, 4, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 2, 3, 10, 4)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 2, 10, 3, 4)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 2, 9, 10, 4)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 5, 6), t3, (7, 8, 9, 10, 5, 6), (7, 8, 9, 0, 10, 2, 3, 4)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 2, 10, 4))
    t4new += einsum(t2, (0, 1, 2, 3), v.ovvv, (1, 4, 3, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 10, 2, 4)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 1, 7, 8, 2, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 1, 7, 8, 9, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 1, 7, 8, 9, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 1, 7, 8, 9, 10, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (0, 1, 6, 7, 8, 9, 10, 11)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 1, 8, 2, 9, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 1, 8, 9, 2, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 1, 8, 9, 10, 2, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 1, 8, 9, 10, 11, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (0, 6, 1, 7, 8, 9, 10, 11)) * -0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 8, 1, 2, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 8, 1, 9, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 8, 1, 9, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (0, 7, 8, 1, 9, 10, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (0, 6, 7, 1, 8, 9, 10, 11)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (0, 7, 8, 9, 2, 3, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (0, 7, 8, 9, 2, 10, 3, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (0, 7, 8, 9, 2, 10, 11, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 2, 9, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (0, 7, 8, 9, 10, 2, 3, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (0, 7, 8, 9, 10, 2, 11, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 9, 2, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (0, 7, 8, 9, 10, 11, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 9, 10, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 9, 10, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (0, 5, 6, 7, 8, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 1, 8, 2, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 1, 8, 9, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 1, 8, 9, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 1, 8, 9, 10, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (6, 0, 1, 7, 8, 9, 10, 11)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 8, 1, 2, 9, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 8, 1, 9, 2, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 8, 1, 9, 10, 2, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 0, 8, 1, 9, 10, 11, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (6, 0, 7, 1, 8, 9, 10, 11)) * -0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 0, 8, 9, 2, 3, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 0, 8, 9, 2, 10, 3, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 0, 8, 9, 2, 10, 11, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 2, 9, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 0, 8, 9, 10, 2, 3, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 0, 8, 9, 10, 2, 11, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 9, 2, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 0, 8, 9, 10, 11, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 9, 10, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 9, 10, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (5, 0, 6, 7, 8, 9, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 8, 0, 1, 2, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 8, 0, 1, 9, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 8, 0, 1, 9, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 3, 6), t4, (7, 8, 4, 5, 9, 10, 11, 6), (7, 8, 0, 1, 9, 10, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (4, 5, 2, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (6, 7, 0, 1, 8, 9, 10, 11)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 0, 9, 2, 3, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 0, 9, 2, 10, 3, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 0, 9, 2, 10, 11, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 2, 9, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 0, 9, 10, 2, 3, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 0, 9, 10, 2, 11, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 9, 2, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 0, 9, 10, 11, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 9, 10, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 9, 10, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (5, 6, 0, 7, 8, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 9, 0, 2, 3, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 9, 0, 2, 10, 3, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 9, 0, 2, 10, 11, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 2, 9, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 9, 0, 10, 2, 3, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 9, 0, 10, 2, 11, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 9, 2, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 5, 6), t4, (7, 8, 9, 4, 10, 11, 5, 6), (7, 8, 9, 0, 10, 11, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 9, 10, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 3, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 9, 10, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (1, 4, 2, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (5, 6, 7, 0, 8, 9, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 2, 3, 10, 11)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 2, 10, 3, 11)) * -0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 2, 10, 11, 3)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 2, 9, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 10, 2, 3, 11)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 10, 2, 11, 3)) * -0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 9, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 10, 11, 2, 3)) * 0.25
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 9, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), v.oovv, (0, 1, 3, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 9, 10, 11, 2)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 8, 5, 9, 6, 10, 7, 11))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 8, 5, 9, 6, 10, 11, 7)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 5, 8, 6, 9, 10, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 8, 5, 9, 6, 7, 10, 11)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 5, 8, 9, 6, 10, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 5, 8, 9, 10, 6, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 5, 8, 9, 10, 11, 6)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 5, 10, 6, 11, 7, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 5, 10, 6, 7, 11, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 5, 10, 6, 7, 8, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 8, 5, 9, 10, 6, 7, 11)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 5, 10, 11, 6, 7, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 8, 5, 9, 10, 6, 11, 7))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 8, 5, 9, 10, 11, 6, 7)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 9, 5, 6, 7, 10, 8, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 9, 5, 6, 7, 10, 11, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 8, 5, 6, 7, 9, 10, 11)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 9, 5, 6, 7, 8, 10, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 9, 5, 6, 10, 7, 8, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 9, 5, 6, 10, 7, 11, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 8, 5, 6, 9, 7, 10, 11)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 9, 5, 6, 10, 11, 7, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 8, 5, 6, 9, 10, 7, 11)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 8, 5, 6, 9, 10, 11, 7)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 8, 9, 5, 6, 10, 7, 11)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 8, 9, 5, 6, 10, 11, 7))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 8, 5, 6, 9, 10, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 8, 9, 5, 6, 7, 10, 11))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 8, 5, 9, 6, 10, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 8, 5, 9, 10, 6, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 7, 8, 5, 9, 10, 11, 6)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 10, 5, 6, 11, 7, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 10, 5, 6, 7, 11, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 10, 5, 6, 7, 8, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 8, 9, 5, 10, 6, 7, 11))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 9, 10, 5, 11, 6, 7, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 8, 9, 5, 10, 6, 11, 7)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 8, 9, 5, 10, 11, 6, 7))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 2), t3, (7, 8, 9, 10, 11, 3), (4, 7, 8, 9, 5, 10, 6, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 7), t3, (8, 9, 10, 11, 2, 3), (4, 8, 9, 10, 5, 11, 6, 7)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 2), t3, (7, 8, 9, 10, 11, 3), (4, 7, 8, 9, 5, 10, 11, 6)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 2), t3, (7, 8, 9, 10, 11, 3), (4, 7, 8, 9, 5, 6, 10, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 7), t3, (8, 9, 10, 11, 2, 3), (4, 8, 9, 10, 5, 6, 11, 7)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 7), t3, (8, 9, 10, 11, 2, 3), (4, 8, 9, 10, 5, 6, 7, 11)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 3), t3, (7, 8, 9, 10, 11, 2), (4, 7, 8, 9, 10, 5, 6, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 7), t3, (8, 9, 10, 11, 2, 3), (4, 8, 9, 10, 11, 5, 6, 7)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 3), t3, (7, 8, 9, 10, 11, 2), (4, 7, 8, 9, 10, 5, 11, 6)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 0, 1, 5, 6, 3), t3, (7, 8, 9, 10, 11, 2), (4, 7, 8, 9, 10, 11, 5, 6)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 5, 8, 9, 6, 10, 7, 11)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 5, 8, 9, 6, 10, 11, 7))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 5, 7, 8, 6, 9, 10, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 7, 2), t3, (8, 9, 1, 10, 11, 3), (4, 5, 8, 9, 6, 7, 10, 11))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 5, 7, 8, 9, 6, 10, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 5, 7, 8, 9, 10, 6, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 0, 6, 2, 3), t3, (7, 8, 1, 9, 10, 11), (4, 5, 7, 8, 9, 10, 11, 6)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 5, 9, 10, 6, 11, 7, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 5, 9, 10, 6, 7, 11, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 5, 9, 10, 6, 7, 8, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 5, 8, 9, 10, 6, 7, 11))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 8), t3, (9, 10, 0, 11, 2, 3), (4, 5, 9, 10, 11, 6, 7, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 5, 8, 9, 10, 6, 11, 7)) * -1.0
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 1, 6, 7, 3), t3, (8, 9, 0, 10, 11, 2), (4, 5, 8, 9, 10, 11, 6, 7))
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 5, 9, 6, 7, 10, 8, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 5, 9, 6, 7, 10, 11, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 8, 6, 7, 9, 10, 11)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 5, 9, 6, 7, 8, 10, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 5, 9, 6, 10, 7, 8, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 5, 9, 6, 10, 7, 11, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 8, 6, 9, 7, 10, 11)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 5, 9, 6, 10, 11, 7, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 8, 6, 9, 10, 7, 11)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 8, 6, 9, 10, 11, 7)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 5, 6, 9, 7, 10, 8, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 5, 6, 9, 7, 10, 11, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 6, 8, 7, 9, 10, 11)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 2), t3, (9, 0, 1, 10, 11, 3), (4, 5, 6, 9, 7, 8, 10, 11)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 5, 6, 9, 10, 7, 8, 11)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 5, 6, 9, 10, 7, 11, 8)) * 0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 6, 8, 9, 7, 10, 11)) * -0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 8, 3), t3, (9, 0, 1, 10, 11, 2), (4, 5, 6, 9, 10, 11, 7, 8)) * -0.5
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 6, 8, 9, 10, 7, 11)) * 0.25
    t4new += einsum(v.oovv, (0, 1, 2, 3), t3, (4, 5, 6, 7, 2, 3), t3, (8, 0, 1, 9, 10, 11), (4, 5, 6, 8, 9, 10, 11, 7)) * -0.25
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 5, 6, 7, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 5, 7, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 5, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 0, 6, 7, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 5, 7, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 5, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 0, 7, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 0, 7, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 5, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 3, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 3, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 8, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 8, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 8, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 8, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (5, 6, 7, 0, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 5, 7, 0, 8, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (2, 4, 5, 1), t3, (6, 7, 4, 8, 9, 10), (6, 7, 5, 0, 8, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 1, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 1, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 1, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 1, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 1, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 1, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 1, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 1, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 1, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 1, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 1, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 1, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 9, 1, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 9, 1, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 9, 1, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 9, 1, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 9, 1, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 9, 1, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 9, 1, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 9, 1, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (4, 6, 7, 8, 9, 10, 1, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 4, 7, 8, 9, 10, 1, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 4, 8, 9, 10, 1, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ooov, (0, 2, 4, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 4, 9, 10, 1, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 2, 6, 7, 5, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 2, 6, 7, 8, 5, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 2, 6, 7, 8, 9, 5, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 2, 6, 7, 8, 9, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 2, 7, 5, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 2, 7, 8, 5, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 2, 7, 8, 9, 5, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 2, 7, 8, 9, 10, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 2, 5, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 2, 8, 5, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 2, 8, 9, 5, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (0, 6, 7, 2, 8, 9, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 3, 4, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 3, 9, 4, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 3, 9, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 4, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 3, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 3, 10, 4))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 4, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 4, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 10, 3, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 4, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 4, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (0, 6, 7, 8, 9, 10, 4, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 2, 7, 5, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 2, 7, 8, 5, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 2, 7, 8, 9, 5, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 2, 7, 8, 9, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 2, 5, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 2, 8, 5, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 2, 8, 9, 5, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 0, 7, 2, 8, 9, 10, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 3, 4, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 3, 9, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 3, 9, 10, 4))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 4, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 3, 4, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 3, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 4, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 4, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 10, 3, 4))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 4, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 4, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 0, 7, 8, 9, 10, 4, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 2, 5, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 2, 8, 5, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 2, 8, 9, 5, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (4, 5, 1, 3), t3, (6, 7, 4, 8, 9, 10), (6, 7, 0, 2, 8, 9, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 3, 4, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 3, 9, 4, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 3, 9, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 4, 3, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 3, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 3, 10, 4))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 4, 9, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 4, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 10, 3, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 4, 9, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 4, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 0, 8, 9, 10, 4, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 3, 4, 9, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 3, 9, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 3, 9, 10, 4))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 4, 3, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 3, 4, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 3, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 4, 9, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 4, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 10, 3, 4))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 4, 9, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 4, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.ovvv, (2, 4, 1, 5), t3, (6, 7, 8, 9, 10, 5), (6, 7, 8, 0, 9, 10, 4, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (0, 2, 6, 7, 8, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (0, 6, 2, 7, 8, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (0, 6, 7, 2, 8, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 3, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 9, 3, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 9, 10, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (0, 6, 7, 8, 9, 10, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (0, 5, 6, 7, 8, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (6, 0, 2, 7, 8, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (6, 0, 7, 2, 8, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 3, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 9, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 9, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 0, 7, 8, 9, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (5, 0, 6, 7, 8, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (4, 5, 1, 3), t4, (6, 7, 4, 5, 8, 9, 10, 11), (6, 7, 0, 2, 8, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 3, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 9, 3, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 9, 10, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 0, 8, 9, 10, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (5, 6, 0, 7, 8, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 3, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 9, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 9, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 5), t4, (6, 7, 8, 4, 9, 10, 11, 5), (6, 7, 8, 0, 9, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (2, 4, 1, 3), t4, (5, 6, 7, 4, 8, 9, 10, 11), (5, 6, 7, 0, 8, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 1, 3, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 1, 10, 3, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 1, 10, 11, 3)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 10, 1, 3, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 10, 1, 11, 3)) * -0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 4, 5), t4, (6, 7, 8, 9, 10, 11, 4, 5), (6, 7, 8, 9, 10, 11, 1, 3)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 3, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 9, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 9, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), v.oovv, (0, 2, 1, 4), t4, (5, 6, 7, 8, 9, 10, 11, 4), (5, 6, 7, 8, 9, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 6, 10, 4, 8, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 6, 10, 4, 8, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 6, 10, 4, 5, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 6, 10, 8, 4, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 6, 10, 8, 4, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 6, 10, 8, 9, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 10, 6, 4, 8, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 10, 6, 4, 8, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 10, 6, 4, 5, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 10, 6, 8, 4, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 10, 6, 8, 4, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 2, 10, 6, 8, 9, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 10, 2, 6, 4, 8, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 10, 2, 6, 4, 8, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 10, 2, 6, 4, 5, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 10, 2, 6, 8, 4, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 10, 2, 6, 8, 4, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (0, 10, 2, 6, 8, 9, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 6, 10, 4, 8, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 6, 10, 4, 8, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 6, 10, 4, 5, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 6, 10, 8, 4, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 6, 10, 8, 4, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 6, 10, 8, 9, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 10, 6, 4, 8, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 10, 6, 4, 8, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 10, 6, 4, 5, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 10, 6, 8, 4, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 10, 6, 8, 4, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 0, 10, 6, 8, 9, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 0, 2, 6, 4, 8, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 0, 2, 6, 4, 8, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 0, 2, 6, 4, 5, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 0, 2, 6, 8, 4, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 0, 2, 6, 8, 4, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 0, 2, 6, 8, 9, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 0, 10, 4, 8, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 0, 10, 4, 8, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 0, 10, 4, 5, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 0, 10, 8, 4, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 0, 10, 8, 4, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 0, 10, 8, 9, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 0, 6, 4, 8, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 0, 6, 4, 8, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 0, 6, 4, 5, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 0, 6, 8, 4, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 0, 6, 8, 4, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 0, 6, 8, 9, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 0, 6, 4, 8, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 0, 6, 4, 8, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 0, 6, 4, 5, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 0, 6, 8, 4, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 0, 6, 8, 4, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 0, 6, 8, 9, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 10, 0, 4, 8, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 10, 0, 4, 8, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 10, 0, 4, 5, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 10, 0, 8, 4, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 10, 0, 8, 4, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 6, 10, 0, 8, 9, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 6, 0, 4, 8, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 6, 0, 4, 8, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 6, 0, 4, 5, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 6, 0, 8, 4, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 6, 0, 8, 4, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (2, 10, 6, 0, 8, 9, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 6, 0, 4, 8, 5, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 6, 0, 4, 8, 9, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 6, 0, 4, 5, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 6, 0, 8, 4, 5, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 6, 0, 8, 4, 9, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (3, 7, 10, 1), (10, 2, 6, 0, 8, 9, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 1, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 1, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 1, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 1, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 1, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 1, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 1, 4, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 1, 4, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 1, 8, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 1, 4, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 1, 4, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 1, 8, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 1, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 1, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 1, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 1, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 1, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 1, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 1, 4, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 1, 4, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 1, 8, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 1, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 1, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 1, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 1, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 1, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 1, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 1, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 1, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 1, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 1, 4, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 1, 4, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 1, 8, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 1, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 1, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 1, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 4, 1, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 8, 1, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 8, 1, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 4, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 8, 1, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 8, 1, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 4, 1, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 4, 1, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 8, 1, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 4, 1, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 4, 1, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 8, 1, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 4, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 8, 1, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 8, 1, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 4, 1, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 8, 1, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 8, 1, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 4, 1, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 4, 1, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 8, 1, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 4, 1, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 8, 1, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 8, 1, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 4, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 8, 1, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 8, 1, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 4, 1, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 8, 1, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 8, 1, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 4, 1, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 4, 1, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 8, 1, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 4, 1, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 8, 1, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 8, 1, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 4, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 8, 4, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 8, 9, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 4, 8, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 8, 4, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 8, 9, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 4, 8, 1, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 4, 5, 1, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 8, 4, 1, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 4, 8, 1, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 4, 5, 1, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 8, 4, 1, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 4, 8, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 8, 4, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 8, 9, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 4, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 8, 4, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 8, 9, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 4, 8, 1, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 4, 5, 1, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 8, 4, 1, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 4, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 8, 4, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 8, 9, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 4, 8, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 8, 4, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 8, 9, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 4, 8, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 8, 4, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 8, 9, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 4, 8, 1, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 4, 5, 1, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 8, 4, 1, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 4, 8, 1, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 8, 4, 1, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 8, 9, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 4, 8, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 8, 4, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 3, 10, 8, 9, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 4, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 8, 4, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 6, 10, 3, 8, 9, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 4, 8, 5, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 4, 5, 8, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 7, 10, 8, 4, 5, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 4, 8, 5, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 4, 5, 8, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 6, 10, 7, 8, 4, 5, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 4, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 8, 4, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 6, 10, 8, 9, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 4, 8, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 8, 4, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 6, 3, 8, 9, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 4, 8, 5, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 4, 5, 8, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (2, 10, 6, 7, 8, 4, 5, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 4, 8, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 8, 4, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 3, 10, 6, 8, 9, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 4, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 8, 4, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (2, 10, 3, 6, 8, 9, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 4, 8, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 8, 4, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 6, 3, 8, 9, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 4, 8, 5, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 4, 5, 8, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 3, 10, 9), (10, 2, 6, 7, 8, 4, 5, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 4, 8, 9, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 8, 4, 9, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ooov, (0, 7, 10, 5), (10, 2, 3, 6, 8, 9, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 10, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 10, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 10, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 4, 10, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 8, 10, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 8, 10, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 4, 8, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 8, 4, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 8, 9, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 4, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 8, 4, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 6, 3, 8, 9, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 10, 4, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 10, 4, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 10, 8, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 4, 10, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 4, 10, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 8, 10, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 4, 8, 10, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 4, 5, 10, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 8, 4, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 4, 8, 5, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 4, 5, 8, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (0, 2, 6, 7, 8, 4, 5, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 10, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 10, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 10, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 4, 10, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 8, 10, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 8, 10, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 4, 8, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 8, 4, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 8, 9, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 4, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 8, 4, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (0, 2, 3, 6, 8, 9, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 10, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 10, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 10, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 4, 10, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 8, 10, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 8, 10, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 4, 8, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 8, 4, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 8, 9, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 4, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 8, 4, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 6, 3, 8, 9, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 10, 4, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 10, 4, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 10, 8, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 4, 10, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 4, 10, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 8, 10, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 4, 8, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 4, 5, 10, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 8, 4, 10, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 4, 8, 5, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 4, 5, 8, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 0, 6, 7, 8, 4, 5, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 10, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 10, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 10, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 4, 10, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 8, 10, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 8, 10, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 4, 8, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 8, 4, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 8, 9, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 4, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 8, 4, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 0, 3, 6, 8, 9, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 10, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 10, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 10, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 4, 10, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 8, 10, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 8, 10, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 4, 8, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 8, 4, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 8, 9, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 4, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 8, 4, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 0, 3, 8, 9, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 10, 4, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 10, 4, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 10, 8, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 4, 10, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 4, 10, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 8, 10, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 4, 8, 10, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 4, 5, 10, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 8, 4, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 4, 8, 5, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 4, 5, 8, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 0, 7, 8, 4, 5, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 10, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 10, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 10, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 4, 10, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 8, 10, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 8, 10, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 4, 8, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 8, 4, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 8, 9, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 4, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 8, 4, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 0, 6, 8, 9, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 10, 4, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 10, 8, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 10, 8, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 4, 10, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 8, 10, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 8, 10, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 4, 8, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 8, 4, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 8, 9, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 4, 8, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 8, 4, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 6, 3, 0, 8, 9, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 10, 4, 8, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 10, 4, 5, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 10, 8, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 4, 10, 8, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 4, 10, 5, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 8, 10, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 4, 8, 10, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 4, 5, 10, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 8, 4, 10, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 4, 8, 5, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 4, 5, 8, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (3, 10, 1, 9), (2, 6, 7, 0, 8, 4, 5, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 10, 4, 8, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 10, 8, 4, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 10, 8, 9, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 4, 10, 8, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 8, 10, 4, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 8, 10, 9, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 4, 8, 10, 9))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 8, 4, 10, 9)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 8, 9, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 4, 8, 9, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 8, 4, 9, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (7, 10, 1, 5), (2, 3, 6, 0, 8, 9, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 1, 10, 4, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 1, 10, 8, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 1, 4, 10, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 1, 8, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 1, 4, 8, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 1, 8, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 1, 10, 4, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 1, 10, 8, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 1, 4, 10, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 1, 8, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 1, 4, 8, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 1, 8, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 1, 10, 4, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 1, 10, 8, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 1, 4, 10, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 1, 8, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 1, 4, 8, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 1, 8, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 10, 1, 4, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 10, 1, 8, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 4, 1, 10, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 8, 1, 10, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 4, 1, 8, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 8, 1, 4, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 10, 1, 4, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 10, 1, 8, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 4, 1, 10, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 8, 1, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 4, 1, 8, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 8, 1, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 10, 1, 4, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 10, 1, 8, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 4, 1, 10, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 8, 1, 10, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 4, 1, 8, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 8, 1, 4, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 10, 4, 1, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 10, 8, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 4, 10, 1, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 8, 10, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 4, 8, 1, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 8, 4, 1, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 10, 4, 1, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 10, 8, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 4, 10, 1, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 8, 10, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 4, 8, 1, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 8, 4, 1, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 10, 4, 1, 8))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 10, 8, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 4, 10, 1, 8)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 8, 10, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 4, 8, 1, 10))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 8, 4, 1, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 10, 4, 8, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 10, 8, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 4, 10, 8, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 8, 10, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 4, 8, 10, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 3, 7, 8, 4, 10, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 10, 4, 8, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 10, 8, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 4, 10, 8, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 8, 10, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 4, 8, 10, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 6, 7, 3, 8, 4, 10, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 10, 4, 8, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 10, 8, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 4, 10, 8, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 8, 10, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 4, 8, 10, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), t2, (6, 7, 8, 9), v.ovvv, (0, 10, 5, 9), (2, 3, 6, 7, 8, 4, 10, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 3, 8, 4, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 3, 8, 9, 4, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 3, 8, 9, 10, 4, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 3, 8, 9, 10, 11, 4)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 8, 3, 4, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 8, 3, 9, 4, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 8, 3, 9, 10, 4, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 2, 8, 3, 9, 10, 11, 4)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 2, 8, 9, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 2, 8, 9, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 2, 8, 9, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 2, 8, 9, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 2, 8, 9, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 2, 8, 9, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 8, 2, 3, 4, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 8, 2, 3, 9, 4, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 8, 2, 3, 9, 10, 4, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (0, 8, 2, 3, 9, 10, 11, 4)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 2, 9, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 2, 9, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 2, 9, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 2, 9, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 2, 9, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 2, 9, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 9, 2, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 9, 2, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 9, 2, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 9, 2, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 9, 2, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (0, 8, 9, 2, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 4, 5, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 4, 10, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 4, 10, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 10, 4, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 10, 4, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 10, 11, 4, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 3, 8, 4, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 3, 8, 9, 4, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 3, 8, 9, 10, 4, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 3, 8, 9, 10, 11, 4)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 8, 3, 4, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 8, 3, 9, 4, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 8, 3, 9, 10, 4, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 0, 8, 3, 9, 10, 11, 4)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 0, 8, 9, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 0, 8, 9, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 0, 8, 9, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 0, 7, 8, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 0, 8, 9, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 0, 8, 9, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 0, 7, 8, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 0, 8, 9, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 0, 7, 8, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 0, 7, 8, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 0, 2, 3, 4, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 0, 2, 3, 9, 4, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 0, 2, 3, 9, 10, 4, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 0, 2, 3, 9, 10, 11, 4)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 2, 9, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 2, 9, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 2, 9, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 2, 9, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 2, 9, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 2, 9, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 9, 2, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 9, 2, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 9, 2, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 9, 2, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 9, 2, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 0, 9, 2, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 4, 5, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 4, 10, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 4, 10, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 10, 4, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 10, 4, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 10, 11, 4, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 0, 8, 4, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 0, 8, 9, 4, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 0, 8, 9, 10, 4, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 0, 8, 9, 10, 11, 4)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 0, 3, 4, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 0, 3, 9, 4, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 0, 3, 9, 10, 4, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 0, 3, 9, 10, 11, 4)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 0, 9, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 0, 9, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 0, 9, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 0, 8, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 0, 9, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 0, 9, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 0, 8, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 0, 9, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 0, 8, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 0, 8, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 0, 3, 4, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 0, 3, 9, 4, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 0, 3, 9, 10, 4, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 0, 3, 9, 10, 11, 4)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 0, 9, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 0, 9, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 0, 9, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 0, 8, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 0, 9, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 0, 9, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 0, 8, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 0, 9, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 0, 8, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 0, 8, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 0, 2, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 0, 2, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 0, 2, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 0, 2, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 0, 2, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 0, 2, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 4, 5, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 4, 10, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 4, 10, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 10, 4, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 10, 4, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 10, 11, 4, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 8, 0, 4, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 8, 0, 9, 4, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 8, 0, 9, 10, 4, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 3, 8, 0, 9, 10, 11, 4)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 3, 0, 4, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 3, 0, 9, 4, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 3, 0, 9, 10, 4, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (2, 8, 3, 0, 9, 10, 11, 4)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 0, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 0, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 0, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 0, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 0, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 0, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 0, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 0, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 0, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 0, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 3, 0, 4, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 3, 0, 9, 4, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 3, 0, 9, 10, 4, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (6, 7, 1, 5), t3, (8, 6, 7, 9, 10, 11), (8, 2, 3, 0, 9, 10, 11, 4)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 0, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 0, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 0, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 0, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 0, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 0, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 0, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 0, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 0, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 0, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 0, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 0, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 0, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 0, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 0, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 0, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 0, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 0, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 0, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (3, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 0, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 4, 5, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 4, 10, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 4, 10, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 10, 4, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 10, 4, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (2, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 10, 11, 4, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 1, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 1, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 1, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 1, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 1, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 1, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 1, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 1, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 1, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 1, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 1, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 1, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 1, 4, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 1, 4, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 1, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 1, 11, 4, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 1, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 1, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 1, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 1, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 1, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 1, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 1, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 1, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 1, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 1, 9, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 1, 4, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 1, 4, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 1, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 1, 11, 4, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 1, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 1, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 1, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 1, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 1, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 1, 9, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 1, 4, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 1, 4, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 1, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 1, 11, 4, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 1, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 1, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 1, 4, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 1, 4, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 1, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 1, 11, 4, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 1, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 1, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 4, 1, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 10, 1, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 10, 1, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 9, 1, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 4, 1, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 10, 1, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 10, 1, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 9, 1, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 4, 1, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 10, 1, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 10, 1, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 9, 1, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 4, 1, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 4, 1, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 4, 1, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 11, 1, 4, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 1, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 1, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 4, 1, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 10, 1, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 10, 1, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 9, 1, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 4, 1, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 10, 1, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 10, 1, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 9, 1, 10, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 4, 1, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 4, 1, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 4, 1, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 11, 1, 4, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 1, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 1, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 4, 1, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 10, 1, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 10, 1, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 9, 1, 10, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 4, 1, 5, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 4, 1, 11, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 4, 1, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 11, 1, 4, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 1, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 1, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 4, 1, 5, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 4, 1, 11, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 4, 1, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 11, 1, 4, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 1, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 1, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 4, 10, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 10, 4, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 10, 11, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 9, 10, 1, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 4, 10, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 10, 4, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 10, 11, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 9, 10, 1, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 4, 10, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 10, 4, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 10, 11, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 9, 10, 1, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 4, 5, 1, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 4, 11, 1, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 4, 10, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 11, 4, 1, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 4, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 11, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 4, 10, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 10, 4, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 10, 11, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 9, 10, 1, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 4, 10, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 10, 4, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 10, 11, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 9, 10, 1, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 4, 5, 1, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 4, 11, 1, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 4, 10, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 11, 4, 1, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 4, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 11, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 4, 10, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 10, 4, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 10, 11, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 9, 10, 1, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 4, 5, 1, 11)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 4, 11, 1, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 4, 10, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 11, 4, 1, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 4, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 11, 1, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 4, 5, 1, 11)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 4, 11, 1, 5)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 4, 10, 1, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 11, 4, 1, 5)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 4, 1, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 11, 1, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 4, 10, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 10, 4, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 3, 8, 9, 10, 11, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 9, 10, 11, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 4, 10, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 10, 4, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 3, 9, 10, 11, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 9, 10, 11, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 4, 10, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 10, 4, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (2, 8, 9, 3, 10, 11, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 9, 10, 11, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 4, 5, 11, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 4, 11, 5, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 4, 10, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (2, 8, 9, 10, 11, 4, 5, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 4, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 11, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 4, 10, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 10, 4, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 3, 9, 10, 11, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 9, 10, 11, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 4, 10, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 10, 4, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 2, 9, 3, 10, 11, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 9, 10, 11, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 4, 5, 11, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 4, 11, 5, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 4, 10, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 2, 9, 10, 11, 4, 5, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 4, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 11, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 4, 10, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 10, 4, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 5, 7), t3, (8, 9, 6, 10, 11, 7), (8, 9, 2, 3, 10, 11, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 4, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 9, 10, 11, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 4, 5, 11, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 4, 11, 5, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 4, 10, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 2, 10, 11, 4, 5, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 4, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 11, 4, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 4, 5, 11, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 4, 11, 5, 1)) * 0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 4, 10, 11, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 6, 7), t3, (8, 9, 10, 11, 6, 7), (8, 9, 10, 2, 11, 4, 5, 1)) * -0.5
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 4, 11, 1))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 5, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 11, 4, 1)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 3, 7, 8, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 3, 8, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (2, 7, 8, 3, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (2, 7, 8, 9, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 3, 8, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 4, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 9, 4, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 9, 10, 4, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 2, 8, 3, 9, 10, 11, 4)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 2, 8, 9, 10, 11, 4, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 4, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 9, 4, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 9, 10, 4, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 6, 1, 5), t3, (7, 8, 6, 9, 10, 11), (7, 8, 2, 3, 9, 10, 11, 4))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 4, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 4, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 4, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 4, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 4, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 2, 9, 10, 11, 4, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 4, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 4, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 4, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 4, 5, 11))
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 4, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t2, (2, 3, 4, 5), v.oovv, (0, 3, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 2, 10, 11, 4, 5))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 2, 6, 10, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 2, 6, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 2, 6, 7, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 2, 10, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 2, 10, 6, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 2, 10, 11, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 6, 2, 10, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 6, 2, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 6, 2, 7, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 10, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 10, 2, 6, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 10, 2, 11, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 6, 10, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 6, 10, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 6, 7, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 10, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 10, 6, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 10, 11, 2, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 6, 10, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 6, 10, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 6, 7, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 8, 1, 10, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 10, 6, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 8, 1, 10, 11, 6, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 8, 1, 6, 10, 7, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 8, 1, 6, 10, 11, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 8, 1, 6, 7, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 8, 1, 10, 6, 7, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 8, 1, 10, 6, 11, 7)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 8, 1, 10, 11, 6, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 2, 6, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 2, 6, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 2, 6, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 2, 10, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 2, 10, 6, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 2, 3, 6, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 2, 10, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 2, 10, 11, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 2, 3, 10, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 8, 5, 2, 10, 3, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 8, 5, 2, 10, 11, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 8, 5, 2, 3, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 6, 2, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 6, 2, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 6, 2, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 10, 2, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 10, 2, 6, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 10, 2, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 10, 2, 11, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 8, 5, 10, 2, 3, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 8, 5, 10, 2, 11, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 6, 10, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 6, 10, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 8, 5, 10, 6, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 10, 6, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 10, 11, 2, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 8, 5, 10, 11, 2, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 6, 10, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 10, 6, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 8, 5, 10, 11, 6, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 2, 6, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 2, 6, 10, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 2, 6, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 2, 6, 7, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 10, 11), (0, 4, 8, 9, 2, 6, 3, 7)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 10, 11), (0, 4, 8, 9, 2, 6, 7, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 2, 10, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 2, 10, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 2, 3, 6, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 10, 11), (0, 4, 8, 9, 2, 3, 6, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 2, 10, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 2, 3, 10, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 6, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 6, 2, 10, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 6, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 6, 2, 7, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 10, 11), (0, 4, 8, 9, 6, 2, 3, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 10, 11), (0, 4, 8, 9, 6, 2, 7, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 10, 2, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 10, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 10, 2, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 6, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 6, 10, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 6, 7, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 10, 11), (0, 4, 8, 9, 6, 7, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 7, 11), (0, 4, 8, 9, 10, 6, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 10, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 6, 10, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 6, 7, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 5, 3, 11), (0, 4, 8, 9, 10, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 2, 6, 10, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 2, 6, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 2, 6, 7, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 2, 10, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 2, 10, 6, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 2, 10, 11, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 6, 2, 10, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 6, 2, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 6, 2, 7, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 10, 2, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 10, 2, 6, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 10, 2, 11, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 6, 10, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 6, 10, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 6, 7, 2, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 10, 6, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 10, 6, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 10, 11, 2, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 6, 10, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 6, 10, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 6, 7, 10, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 4, 1, 8, 10, 6, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 10, 6, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 4, 1, 8, 10, 11, 6, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 1, 8, 6, 10, 7, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 1, 8, 6, 10, 11, 7)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 1, 8, 6, 7, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 1, 8, 10, 6, 7, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 1, 8, 10, 6, 11, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 4, 1, 8, 10, 11, 6, 7)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 2, 6, 10, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 2, 6, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 2, 6, 3, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 2, 10, 6, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 2, 10, 6, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 2, 3, 6, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 2, 10, 3, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 2, 10, 11, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 2, 3, 10, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 5, 8, 2, 10, 3, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 5, 8, 2, 10, 11, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 5, 8, 2, 3, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 6, 2, 10, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 6, 2, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 6, 2, 3, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 10, 2, 6, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 10, 2, 6, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 10, 2, 3, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 10, 2, 11, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 5, 8, 10, 2, 3, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 5, 8, 10, 2, 11, 3)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 6, 10, 2, 3))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 6, 10, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 7, 11), (0, 4, 5, 8, 10, 6, 2, 3)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 10, 6, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 10, 11, 2, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 6, 7), (0, 4, 5, 8, 10, 11, 2, 3)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 6, 10, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 10, 6, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (1, 9, 3, 7), (0, 4, 5, 8, 10, 11, 6, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 2, 6, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 2, 10, 6, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 2, 10, 11, 6)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 6, 2, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 10, 2, 6, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 10, 2, 11, 6)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 6, 10, 2, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 10, 6, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 10, 11, 2, 6)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 6, 10, 11, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 10, 6, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 1, 5, 10, 11, 6, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 2, 6, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 2, 10, 6, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 2, 10, 11, 6)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 6, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 10, 2, 6, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 10, 2, 11, 6)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 6, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 10, 6, 2, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 10, 11, 2, 6)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 6, 10, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 10, 6, 11, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 4, 5, 1, 10, 11, 6, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 2, 6, 10, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 2, 6, 10, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 2, 6, 7, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 2, 10, 6, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 2, 10, 6, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 2, 10, 11, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 6, 2, 10, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 6, 2, 10, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 6, 2, 7, 10)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 10, 2, 6, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 10, 2, 6, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 10, 2, 11, 6)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 6, 10, 2, 7)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 6, 10, 2, 11))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 6, 7, 2, 10))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 10, 6, 2, 7))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 10, 6, 2, 11)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 10, 11, 2, 6))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 6, 10, 7, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 6, 10, 11, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 6, 7, 10, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 11), (0, 1, 4, 8, 10, 6, 7, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 10, 6, 11, 2))
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 3, 7), (0, 1, 4, 8, 10, 11, 6, 2)) * -1.0
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 1, 4, 8, 6, 10, 7, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 1, 4, 8, 6, 10, 11, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 1, 4, 8, 6, 7, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 1, 4, 8, 10, 6, 7, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 1, 4, 8, 10, 6, 11, 7)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 2, 3), (0, 1, 4, 8, 10, 11, 6, 7)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 2, 6, 10, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 2, 10, 6, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 2, 10, 11, 6)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 6, 2, 10, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 10, 2, 6, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 10, 2, 11, 6)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 6, 10, 2, 11)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 10, 6, 2, 11)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 10, 11, 2, 6)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 6, 10, 11, 2)) * 0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 10, 6, 11, 2)) * -0.5
    t4new += einsum(t2, (0, 1, 2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (8, 9, 3, 7), (0, 1, 4, 5, 10, 11, 6, 2)) * 0.5
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 5, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 9, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 9, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 2, 7, 8, 9, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 5, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 9, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 9, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 2, 8, 9, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 5, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 9, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 9, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (0, 7, 8, 2, 9, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 3, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 3, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 3, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 10, 3, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 10, 3, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (0, 7, 8, 9, 10, 11, 3, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 5, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 9, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 9, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 2, 8, 9, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 5, 9, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 9, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 9, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 0, 8, 2, 9, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 3, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 3, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 3, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 10, 3, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 10, 3, 11, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 0, 8, 9, 10, 11, 3, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 5, 9, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 9, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 9, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (4, 6, 1, 3), t3, (7, 8, 6, 9, 10, 11), (7, 8, 0, 2, 9, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 3, 5, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 3, 10, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 3, 10, 11, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 10, 3, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 10, 3, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 0, 9, 10, 11, 3, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 3, 5, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 3, 10, 5, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 3, 10, 11, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 10, 3, 5, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 10, 3, 11, 5))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t1, (4, 5), v.oovv, (2, 4, 1, 6), t3, (7, 8, 9, 10, 11, 6), (7, 8, 9, 0, 10, 11, 3, 5)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 2, 4, 8, 6, 10, 7, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 2, 4, 8, 6, 10, 11, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 2, 4, 8, 6, 7, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 2, 4, 8, 10, 6, 7, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 2, 4, 8, 10, 6, 11, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 2, 4, 8, 10, 11, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 2, 8, 6, 10, 7, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 2, 8, 6, 10, 11, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 2, 8, 6, 7, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 2, 8, 10, 6, 7, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 2, 8, 10, 6, 11, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 2, 8, 10, 11, 6, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 8, 2, 6, 10, 7, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 8, 2, 6, 10, 11, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 8, 2, 6, 7, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 8, 2, 10, 6, 7, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 8, 2, 10, 6, 11, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (0, 4, 8, 2, 10, 11, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 3, 6, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 3, 10, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 3, 10, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 3, 6, 10, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 3, 6, 7, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 3, 10, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 3, 6, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 3, 10, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 3, 10, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 6, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 10, 3, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 10, 3, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 6, 3, 10, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 6, 3, 7, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 10, 3, 6, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 6, 3, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 10, 3, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 10, 3, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 6, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 10, 6, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 10, 11, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 6, 10, 3, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 6, 7, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 10, 6, 3, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 6, 10, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 10, 6, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 10, 11, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 6, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 10, 6, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 8, 5, 10, 11, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 6, 10, 7, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 6, 7, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (0, 4, 8, 9, 10, 6, 7, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 6, 10, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 10, 6, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (0, 4, 5, 8, 10, 11, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 2, 8, 6, 10, 7, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 2, 8, 6, 10, 11, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 2, 8, 6, 7, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 2, 8, 10, 6, 7, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 2, 8, 10, 6, 11, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 2, 8, 10, 11, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 8, 2, 6, 10, 7, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 8, 2, 6, 10, 11, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 8, 2, 6, 7, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 8, 2, 10, 6, 7, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 8, 2, 10, 6, 11, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 0, 8, 2, 10, 11, 6, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 3, 6, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 3, 10, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 3, 10, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 3, 6, 10, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 3, 6, 7, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 3, 10, 6, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 3, 6, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 3, 10, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 3, 10, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 6, 3, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 10, 3, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 10, 3, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 6, 3, 10, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 6, 3, 7, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 10, 3, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 6, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 10, 3, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 10, 3, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 6, 10, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 10, 6, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 10, 11, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 6, 10, 3, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 6, 7, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 10, 6, 3, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 6, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 10, 6, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 10, 11, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 6, 10, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 10, 6, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 8, 5, 10, 11, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 6, 10, 7, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 6, 7, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 0, 8, 9, 10, 6, 7, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 6, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 10, 6, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 0, 5, 8, 10, 11, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 8, 0, 2, 6, 10, 7, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 8, 0, 2, 6, 10, 11, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 8, 0, 2, 6, 7, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 8, 0, 2, 10, 6, 7, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 8, 0, 2, 10, 6, 11, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (5, 9, 1, 3), (4, 8, 0, 2, 10, 11, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 3, 6, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 3, 10, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 3, 10, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 3, 6, 10, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 3, 6, 7, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 3, 10, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 3, 6, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 3, 10, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 3, 10, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 6, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 10, 3, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 10, 3, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 6, 3, 10, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 6, 3, 7, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 10, 3, 6, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 6, 3, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 10, 3, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 10, 3, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 6, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 10, 6, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 10, 11, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 6, 10, 3, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 6, 7, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 10, 6, 3, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 6, 10, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 10, 6, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 10, 11, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 6, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 10, 6, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 0, 5, 10, 11, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 6, 10, 7, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 6, 7, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 0, 9, 10, 6, 7, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 6, 10, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 10, 6, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 0, 8, 10, 11, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 3, 6, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 3, 10, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 3, 10, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 3, 6, 10, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 3, 6, 7, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 3, 10, 6, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 3, 6, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 3, 10, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 3, 10, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 6, 3, 10, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 10, 3, 6, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 10, 3, 11, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 6, 3, 10, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 6, 3, 7, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 10, 3, 6, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 6, 3, 10, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 10, 3, 6, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 10, 3, 11, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 6, 10, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 10, 6, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 10, 11, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 6, 10, 3, 7)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 6, 7, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 10, 6, 3, 7))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 6, 10, 3, 11))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 10, 6, 3, 11)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 10, 11, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 6, 10, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 10, 6, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 8, 5, 0, 10, 11, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 6, 10, 7, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 6, 7, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 5, 1, 11), (4, 8, 9, 0, 10, 6, 7, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 6, 10, 11, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 10, 6, 11, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (2, 9, 1, 7), (4, 5, 8, 0, 10, 11, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 1, 3, 6, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 1, 3, 10, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 1, 3, 6, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 1, 3, 10, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 1, 3, 6, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 1, 3, 10, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 1, 6, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 1, 10, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 1, 6, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 1, 10, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 1, 6, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 1, 10, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 1, 6, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 1, 10, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 1, 6, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 1, 10, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 1, 6, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 1, 10, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 6, 1, 3, 10))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 10, 1, 3, 6)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 6, 1, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 10, 1, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 6, 1, 3, 10)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 10, 1, 3, 6))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 6, 1, 10, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 10, 1, 6, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 6, 1, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 10, 1, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 6, 1, 10, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 10, 1, 6, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 6, 10, 1, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 5, 9, 10, 6, 1, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 6, 10, 1, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 8, 9, 5, 10, 6, 1, 3))
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 6, 10, 1, 3)) * -1.0
    t4new += einsum(t1, (0, 1), t1, (2, 3), t2, (4, 5, 6, 7), t2, (8, 9, 10, 11), v.oovv, (0, 2, 7, 11), (4, 5, 8, 9, 10, 6, 1, 3))

    return {"t1new": t1new, "t2new": t2new, "t3new": t3new, "t4new": t4new}

